/*****************************************************************************/
/*  Copyright (C) NEC Corporation 2010 All rights reserved.                  */
/*  File Name    : AMTK.h                                                    */
/*  Abstract     : AMTK header file                                          */
/*                                                                           */
/*  Author     NEC                                                           */
/*  Date       2012/12/03                                                    */
/*  Version    1.11                                                          */
/*             1.12 2014/12/26 AM2_DEF_RMISS    -9999.0 -> -9999.99          */
/*  Notice                                                                   */
/*****************************************************************************/
#ifndef AMTK_H
#define AMTK_H

#ifndef INC_HDF
typedef int hid_t;
typedef int herr_t;
#else
#include <hdf5.h>
#endif

#ifdef LINUX
#include <byteswap.h>
#endif



/*****************************************************************************/
/*    Access label definition                                                */
/*****************************************************************************/

/* L1A */

#define	AM2_SCAN_TIME_DEF	10010
#define AM2_POS_ORBIT		10020
#define AM2_NAVI			10030
#define AM2_ATT				10040
#define AM2_OC06V			10050
#define AM2_OC06H			10060
#define AM2_OC07V			10070
#define AM2_OC07H			10080
#define AM2_OC10V			10090
#define AM2_OC10H			10100
#define AM2_OC18V			10110
#define AM2_OC18H			10120
#define AM2_OC23V			10130
#define AM2_OC23H			10140
#define AM2_OC36V			10150
#define AM2_OC36H			10160
#define AM2_OC89AV			10170
#define AM2_OC89AH			10180
#define AM2_OC89BV			10190
#define AM2_OC89BH			10200
#define AM2_OC_LO			10210
#define AM2_OC_89A			10220
#define AM2_OC_89B			10230
#define AM2_HTS_LO			10240
#define AM2_HTS_HI			10250
#define AM2_CSM_LO			10260
#define AM2_CSM_HI			10270
#define AM2_OFF_GAIN		10290
#define AM2_SUN_AZ			10300
#define AM2_SUN_EL			10310
#define AM2_EARTH_INC		10320
#define AM2_EARTH_AZ		10330
#define AM2_LOF_LO			10340
#define AM2_LOF_HI			10350
#define AM2_OB_SPL			10420
#define AM2_SPC_TEMP		10430
#define AM2_SPS_TEMP		10440
#define AM2_PCD				10450
#define AM2_SCAN_QUAL		10460
#define AM2_PIX_QUAL_LO		10470
#define AM2_PIX_QUAL_HI		10480
#define AM2_INTPL_LO		10490
#define AM2_INTPL_HI		10500
#define AM2_SPL_OV			10510 /* unused: XU05-AI-FY2012-0001 Remove [Spill Over] */

/* L1B */

#define AM2_TB06V			11050
#define AM2_TB06H			11060
#define AM2_TB07V			11070
#define AM2_TB07H			11080
#define AM2_TB10V			11090
#define AM2_TB10H			11100
#define AM2_TB18V			11110
#define AM2_TB18H			11120
#define AM2_TB23V			11130
#define AM2_TB23H			11140
#define AM2_TB36V			11150
#define AM2_TB36H			11160
#define AM2_TB89AV			11170
#define AM2_TB89AH			11180
#define AM2_TB89BV			11190
#define AM2_TB89BH			11200
#define AM2_TB_LO			11210
#define AM2_TB_89A			11220
#define AM2_TB_89B			11230

/* L1R */

#define AM2_RES06_TB06V		12050
#define AM2_RES06_TB06H		12060
#define AM2_RES06_TB07V		12070
#define AM2_RES06_TB07H		12080
#define AM2_RES06_TB10V		12090
#define AM2_RES06_TB10H		12100
#define AM2_RES06_TB18V		12110
#define AM2_RES06_TB18H		12120
#define AM2_RES06_TB23V		12130
#define AM2_RES06_TB23H		12140
#define AM2_RES06_TB36V		12150
#define AM2_RES06_TB36H		12160
#define AM2_RES06_TB89V		12170
#define AM2_RES06_TB89H		12180
#define AM2_RES06_TB_ALL	12190
#define AM2_RES10_TB10V		12200
#define AM2_RES10_TB10H		12210
#define AM2_RES10_TB18V		12220
#define AM2_RES10_TB18H		12230
#define AM2_RES10_TB23V		12240
#define AM2_RES10_TB23H		12250
#define AM2_RES10_TB36V		12260
#define AM2_RES10_TB36H		12270
#define AM2_RES10_TB89V		12280
#define AM2_RES10_TB89H		12290
#define AM2_RES10_TB_ALL	12300
#define AM2_RES23_TB18V		12310
#define AM2_RES23_TB18H		12320
#define AM2_RES23_TB23V		12330
#define AM2_RES23_TB23H		12340
#define AM2_RES23_TB36V		12350
#define AM2_RES23_TB36H		12360
#define AM2_RES23_TB89V		12370
#define AM2_RES23_TB89H		12380
#define AM2_RES23_TB_ALL	12390
#define AM2_RES36_TB36V		12400
#define AM2_RES36_TB36H		12410
#define AM2_RES36_TB89V		12420
#define AM2_RES36_TB89H		12430
#define AM2_RES36_TB_ALL	12440
#define AM2_MEAN_HEIGHT		12510
#define AM2_LOF_RES_LO		12560
#define AM2_LOF_RES_HI		12570

/* L2 */

#define AM2_SWATH_GEO1		21030
#define AM2_SWATH_GEO2		21040
#define AM2_SWATH_GEO3		21050
#define AM2_SWATH_GEOA		21060
#define AM2_PIX_QUAL		21070
#define AM2_SWATHA_GEO1		22030
#define AM2_SWATHA_GEO2		22040
#define AM2_SWATHA_GEO3		22050
#define AM2_SWATHA_GEOA		22060
#define AM2_SWATHB_GEO1		22070
#define AM2_SWATHB_GEO2		22080
#define AM2_SWATHB_GEO3		22090
#define AM2_SWATHB_GEOA		22100
#define AM2_PIX_QUAL_A		22110
#define AM2_PIX_QUAL_B		22120

/* L3 */

#define AM2_GRID_TBV		31010
#define AM2_GRID_TBH		31020
#define AM2_GRID_TB			31030
#define AM2_GRID_TIME		31040
#define AM2_GRID_GEO1		31310
#define AM2_GRID_GEO2		31320
#define AM2_GRID_GEO3		31330
#define AM2_GRID_GEOA		31340

/* L3 */

#define AM2_GRID_TBV_STD	34140
#define AM2_GRID_TBH_STD	34150
#define AM2_GRID_TB_STD		34160
#define AM2_GRID_TBV_ANUM	34170
#define AM2_GRID_TBH_ANUM	34180
#define AM2_GRID_TB_ANUM	34190
#define AM2_GRID_TBV_TNUM	34200
#define AM2_GRID_TBH_TNUM	34210
#define AM2_GRID_TB_TNUM	34220
#define AM2_GRID_GEO1_STD	34510
#define AM2_GRID_GEO2_STD	34520
#define AM2_GRID_GEO3_STD	34530
#define AM2_GRID_GEOA_STD	34540
#define AM2_GRID_GEO1_ANUM	34550
#define AM2_GRID_GEO2_ANUM	34560
#define AM2_GRID_GEO3_ANUM	34570
#define AM2_GRID_GEOA_ANUM	34580
#define AM2_GRID_GEO1_TNUM	34590
#define AM2_GRID_GEO2_TNUM	34600
#define AM2_GRID_GEO3_TNUM	34610
#define AM2_GRID_GEOA_TNUM	34620

/* LATLON */

#define AM2_LATLON_06		40010
#define AM2_LATLON_07		40020
#define AM2_LATLON_10		40030
#define AM2_LATLON_18		40040
#define AM2_LATLON_23		40050
#define AM2_LATLON_36		40060
#define AM2_LATLON_89A		40070
#define AM2_LATLON_89B		40080
#define AM2_LATLON_LO		40090
#define AM2_LATLON_RS_89A	40100
#define AM2_LATLON_RS_89B	40110
#define AM2_LATLON_RS_LO	40120
#define AM2_LATLON_L2_LO	40130
#define AM2_LATLON_L2_89A	40140
#define AM2_LATLON_L2_89B	40150
#define AM2_GRID_LATLON		40160


#define AM2_DEF_SNUM_LO			243
#define AM2_DEF_SNUM_HI			486
#define AM2_DEF_L3H_EQ_X		3600
#define AM2_DEF_L3H_EQ_Y		1800
#define AM2_DEF_L3L_EQ_X		1440
#define AM2_DEF_L3L_EQ_Y		720
#define AM2_DEF_L3H_EQ_GSIZE	0.1
#define AM2_DEF_L3L_EQ_GSIZE	0.25
#define AM2_DEF_L3H_PN1_X		760
#define AM2_DEF_L3H_PN1_Y		1120
#define AM2_DEF_L3L_PN1_X		304
#define AM2_DEF_L3L_PN1_Y		448
#define AM2_DEF_L3H_PN2_X		1080
#define AM2_DEF_L3H_PN2_Y		1435
#define AM2_DEF_L3L_PN2_X		432
#define AM2_DEF_L3L_PN2_Y		574
#define AM2_DEF_L3H_PS_X		790
#define AM2_DEF_L3H_PS_Y		830
#define AM2_DEF_L3L_PS_X		316
#define AM2_DEF_L3L_PS_Y		332
#define AM2_DEF_CAL_LO			16
#define AM2_DEF_CAL_HI			32

#define AM2_HIGH      486
#define AM2_LOW       243

#define AM2CAL_L      16
#define AM2CAL_H     32

#define AM2_MISS_SHORT    9999
#define AM2_MISS_UCHAR    99
#define AM2_MISS_FLOAT    -999.9


/* MISS Value */
#define AM2_DEF_IMISS    -32768
#define AM2_DEF_UIMISS    65535
#define AM2_DEF_CMISS       255
#define AM2_DEF_RMISS    -9999.99

#define A2HIGH      392         
#define A2LOW       196

#define AM2_DTYPE_INT    1
#define AM2_DTYPE_UCHAR  2
#define AM2_DTYPE_FLOAT  3
#define AM2_DTYPE_DOUBLE 4

#define AM2_SCANNUM_NOCHK -9999

#define	AM2_GRID03D_FNAME_MAX 5
#define	AM2_GRID03D_FNAME_LEN 512

#define AM2_START_SCANNUM_ALL  AM2_SCANNUM_NOCHK
#define AM2_END_SCANNUM_ALL    AM2_SCANNUM_NOCHK

#define AM2_RW_MODE       1
#define AM2_CREATE_MODE   2

#ifndef _AM2_COMMON_LATLON
#define _AM2_COMMON_LATLON
/*****************************************************************************/
/*    AMTK LATLON                                                            */
/*****************************************************************************/
	typedef struct
	{
		float   lat;
		float   lon;
	}AM2_COMMON_LATLON;
#endif

#ifndef _AM2_COMMON_SCANTIME
#define _AM2_COMMON_SCANTIME
/*****************************************************************************/
/*    AMTK SCANTIME                                                          */
/*****************************************************************************/
	typedef struct {
		double  tai93sec;         /* total sec. beginning 1993/01/01  */
		short   year;
		short   month;
		short   day;
		short   hour;
		short   minute;
		short   second;
		short   ms;
		short   reserve;
	} AM2_COMMON_SCANTIME;
#endif

/*****************************************************************************/
/*    AMTK SCAN_DATA_QUALITY                                                 */
/*****************************************************************************/
	typedef struct AMTK_SCAN_DATA_QUALITY
	{
		float			angular_direction[2];
		unsigned int	quality_of_packet;
		float			angular_velocity;
		float			calibration[64];
		unsigned int	spc_sps_error;
		float			hts_temperature[16];
		unsigned int	parity_error[33];
		unsigned int	quality_info[4];
		unsigned int	spare[6];
	} AMTK_SCAN_DATA_QUALITY;

/*****************************************************************************/
/*    Function prototypes                                                    */
/*****************************************************************************/
	hid_t AMTK_openH5(char *file_name);
	int AMTK_closeH5(hid_t HDF_file_id);
	int AMTK_getDimSize(hid_t HDF_file_id,int dataset_no , int *size);
	int AMTK_getMetaDataName(hid_t HDF_file_id, char *name, char **value);
	int AMTK_getMetaData(hid_t HDF_file_id, int index, char **value);
	int AMTK_getScanTime(hid_t HDF_file_id, int from_scan, int to_scan, AM2_COMMON_SCANTIME **scan_time);
	int AMTK_getLatLon(hid_t HDF_file_id, AM2_COMMON_LATLON **latlon, int from_scan, int to_scan, int dataset_no);
	int AMTK_get_ScanDataQuality(hid_t HDF_file_id, AMTK_SCAN_DATA_QUALITY **quality, int from_scan, int to_scan, int dataset_no);
	int AMTK_get_SwathInt(hid_t HDF_file_id, int **data, int from_scan, int to_scan, int dataset_no);
	int AMTK_get_SwathFloat(hid_t HDF_file_id, float **data, int from_scan, int to_scan, int dataset_no);
	int AMTK_get_SwathDouble(hid_t HDF_file_id, double **data, int from_scan, int to_scan, int dataset_no);
	int AMTK_get_SwathUChar(hid_t HDF_file_id, unsigned char **data, int from_scan, int to_scan, int dataset_no);

/*********************************************************************************/

	hid_t AMTK_openH5_Write (char *file_name, int mode);
	int AMTK_closeH5_Write (hid_t HDF_file_id);
	int AMTK_setDimSize(hid_t HDF_file_id,int dataset_no , int *size);
	int AMTK_setMetaDataName(hid_t HDF_file_id, char *name, char *value);
	int AMTK_setMetaData(hid_t HDF_file_id, int index, char *value);
	int AMTK_setScanTime(hid_t HDF_file_id, AM2_COMMON_SCANTIME *scan_time, int from_scan, int to_scan);
	int AMTK_setLatLon(hid_t HDF_file_id, AM2_COMMON_LATLON *latlon, int from_scan, int to_scan, int dataset_no);
	int AMTK_set_ScanDataQuality(hid_t HDF_file_id, AMTK_SCAN_DATA_QUALITY *quality, int from_scan, int to_scan, int dataset_no);
	int AMTK_set_SwathInt(hid_t HDF_file_id, int *data, int from_scan, int to_scan, int dataset_no);
	int AMTK_set_SwathFloat(hid_t HDF_file_id, float *data, int from_scan, int to_scan, int dataset_no);
	int AMTK_set_SwathDouble(hid_t HDF_file_id, double *data, int from_scan, int to_scan, int dataset_no);
	int AMTK_set_SwathUChar(hid_t HDF_file_id, unsigned char *data, int from_scan, int to_scan, int dataset_no);

/*********************************************************************************/

	int AMTK_get_GridInt(hid_t HDF_file_id, int **data, int dataset_no);
	int AMTK_get_GridFloat(hid_t HDF_file_id, float **data, int dataset_no);

	int AMTK_get_Grid03D(float **average, char *name_table);
	int AMTK_set_GridInt(hid_t HDF_file_id, int *data, int dataset_no);
	int AMTK_set_GridFloat(hid_t HDF_file_id, float *data, int dataset_no);


/*********************************************************************************/
	/* ADD START sh-tanaka 2010-08-23 : [GCOM-W1] TAI93 Setter. */
	int AMTK_setScanTime_TAI93(hid_t HDF_file_id, AM2_COMMON_SCANTIME *scan_time, int from_scan, int to_scan);
	/* ADD END   sh-tanaka 2010-08-23 : [GCOM-W1] TAI93 Setter. */

#endif
