/*****************************************************************************/
/*  Copyright (C) NEC Corporation 2010 All rights reserved.                  */
/*  File Name    : sample_common.h                                           */
/*  Abstract     : I/O toolkit sample program                                */
/*  Author     NEC                                                           */
/*  Date       2010/12/09                                                    */
/*  Version    1.08                                                          */
/*  Notice                                                                   */
/*****************************************************************************/

#ifndef _SAMPLE_COMMON_H_AMTK_
#define _SAMPLE_COMMON_H_AMTK_

#include <stdlib.h>

/** output error message. */
#if __STDC_VERSION__ >= 199901L
/* C99 */
#define E_MSG(...) \
{\
	printf("%s(%d)[%s]:", __FILE__, __LINE__, __func__); \
	printf(__VA_ARGS__); \
}
#else
/* not C99 */
#define E_MSG printf("%s(%d):", __FILE__, __LINE__); printf
#endif


/*---------------------------------------------------------------------------*
 * Common definition                                                         *
 *---------------------------------------------------------------------------*/
 
/** Metadata number maximum. */
#define META_DATA_NUM_MAX      (200)
/** Metadata length maximum. */
#define META_DATA_LEN_MAX      (512 + 1)

/** Return value. */
enum RETURN_VALUE
{
	RET_NORMAL,
	RET_ERROR
};


/** Get memory size.
 * @param  p_dimsize  [IN]Dimension size (int[3])
 * @return Memory size
 */
size_t get_memory_size(const int *p_dimsize);

/** Get metadata(sample).
 * @param  p_filepath   [IN] Sample file path
 * @param  p_meta_name  [OUT]Metadata name
 * @param  p_meta_value [OUT]Metadata value
 * @param  p_meta_num   [OUT]Number of metadata
 * @return true value : success
 * @return false value: error
 */
int get_metadata_sample(
	const char *p_filepath,
	char (*p_meta_name)[META_DATA_LEN_MAX],
	char (*p_meta_value)[META_DATA_LEN_MAX],
	int *p_meta_num);

#endif

