C*****************************************************************************
C*  Copyright (C) NEC Corporation 2010 All rights reserved.                  *
C*  File Name    : sample13_read_L1Rproduct.f                                *
C*  Abstract     : I/O toolkit sample program                                *
C*  Function List                                                            *
C*      main                         : Sample program main                   *
C*                                                                           *
C*  Author     NEC                                                           *
C*  Date       2011/03/01                                                    *
C*  Version    1.09                                                          *
C*  Notice                                                                   *
C*****************************************************************************
      Program main

      Implicit NONE

      include 'AMTK_f.h'


C     PRINT_SCAN_NUM defines print data number
      Integer, PARAMETER ::  PRINT_SCAN_NUM = 2
C     Number of Scans(Variable size)
      integer, PARAMETER :: NUM_SCANS_VAR = 2000
      
      character*40 fname
      data fname/'../data/sample12_IOToolKit_l1r_f.h5'/
      character*40 meta
      data meta/'../data/metadata_sample_L1R.txt'/

C     Sample meta data read
      character*512 buffer
      integer*1 datax(512)
      
      character*512  label(4)
      integer*1 idx(512)
      integer*1 metadata_name(512)
      integer*1 max_size(512)
      integer*1 metadata_value(512)

      character*1024 metadata_area_buff
      integer*1 metadata_area(1024)
      equivalence(metadata_area_buff, metadata_area)
c

      Integer file_id
      Integer meta_data_num
      Integer scan_num
      Integer pixel_num

      Integer status
      Integer i
      Integer j
      equivalence(buffer, datax)
      equivalence(label(1), idx)
      equivalence(label(2), metadata_name)
      equivalence(label(3), max_size)
      equivalence(label(4), metadata_value)

      Integer dim_size(3)

      Integer lines
      Integer scan_size
      Integer scan_start
      Integer scan_end
      Integer num_scans
      Integer num_overlap_scans
      Character*4 buf_num_scans
      Character*1 buf_num_overlap_scans

C--------------------------------------------------------------------C
C    *definition of data set variable.                               C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C    *Scan Time
      type(AM2_COMMON_SCANTIME) scan_time(NUM_SCANS_VAR)

C    *Position in Orbit
      Real*8 pos_orbit(NUM_SCANS_VAR)

C    *Navigation Data
      Real navi(6, NUM_SCANS_VAR)

C    *Attitude Data
      Real att(3, NUM_SCANS_VAR)

C    *Brightness Temperature <06GHz resolution>
      Real res06_tb06v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb06h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb07v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb07h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb10v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb10h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res06_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Brightness Temperature <10GHz resolution>
      Real res10_tb10v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb10h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res10_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Brightness Temperature <23GHz resolution>
      Real res23_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res23_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      
C    *Brightness Temperature <36GHz resolution>
      Real res36_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res36_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res36_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real res36_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      
C    *Brightness Temperature <36GHz resolution>
      Real res89_tb89av(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real res89_tb89ah(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real res89_tb89bv(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real res89_tb89bh(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      
C    *Latitude of Observation Point for 89A
C    *Longitude of Observation Point for 89A
      type(AM2_COMMON_LATLON) latlon_89a(AM2_DEF_SNUM_HI,
     *    NUM_SCANS_VAR)

C    *Latitude of Observation Point for 89B
C    *Longitude of Observation Point for 89B
      type(AM2_COMMON_LATLON) latlon_89b(AM2_DEF_SNUM_HI,
     *    NUM_SCANS_VAR)

C    *Area Mean Height
      Real height(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Sun Azimuth
      Real sun_azim(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Sun Elevation
      Real sun_elev(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Earth Incidence
      Real eth_inci(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Earth Azimuth
      Real eth_azim(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Land_Ocean Flag 6 to 36
      Integer lof_low(AM2_DEF_SNUM_LO, NUM_SCANS_VAR, 6)

C    *Land_Ocean Flag 89
      Integer lof_high(AM2_DEF_SNUM_HI, NUM_SCANS_VAR, 2)

C    *Scan Data Quality
      type(AMTK_SCAN_DATA_QUALITY) scanqual(NUM_SCANS_VAR)

C    *Pixel Data Quality 6 to 36
C    *(Numbef of scans * 486[243 * binary 2byte])
      Character pixqual_low(AM2_DEF_SNUM_LO * 2, NUM_SCANS_VAR)

C    *Pixel Data Quality 89
C    *(Numbef of scans * 486[486 * binary 1byte])
      Character pixqual_high(AM2_DEF_SNUM_HI * 1, NUM_SCANS_VAR)

C--------------------------------------------------------------------C
C    *input data                                                     C
C--------------------------------------------------------------------C

      lines = 0

C     HDF product file open
      file_id = AMTK_openH5(fname)
      if (file_id.lt.0) then
          write(*,*) 'AMTK_openH5 ERROR' ,file_id
          stop
      endif
      
C     sample meta data read
C     Read Metadata from Metadata file
      open(10, file=meta, status='old')

  555 read(10, 100, end=999) buffer
  100 format(A512)
c
      lines = lines + 1
c
      do i=1,512
          idx(i) = 32
          metadata_name(i) = 32
          max_size(i) = 32
          metadata_value(i) = 32
      end do
c
      i=1
      j=1
   10 if( datax(i).ne.9 ) then
          idx(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 10
      endif
c
      i=i+1
      j=1
   20 if( datax(i).ne.9 ) then
          metadata_name(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 20
      endif
c
      i=i+1
      j=1
   30 if( datax(i).ne.9 ) then
          max_size(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 30
      endif
c
      i=i+1
      j=1
   40 if( i.lt.512 .and. datax(i).ne.0 .and. datax(i).ne.9) then
          metadata_value(j) = datax(i)
          i = i + 1
          j = j + 1
          goto 40
      endif

      do i=1,1024
          metadata_area(i) = 32
      end do

      status = AMTK_getMetaDataName(file_id, 
     *    label(2),metadata_area_buff)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      if( status.ne.0) then
         write(*,*) 'No=', lines, 'Name=',trim(label(2)),
     *    ' Value=',metadata_area_buff(1:status)
      endif

      goto 555

  999 meta_data_num = lines

      Close(10)

C     Get scan size.
      buf_num_scans = ''
      status = AMTK_getMetaDataName(file_id, 'NumberOfScans',
     *    buf_num_scans)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      READ(buf_num_scans, *) num_scans
      
      buf_num_overlap_scans = ''
      status = AMTK_getMetaDataName(file_id, 'OverlapScans',
     *    buf_num_overlap_scans)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      READ(buf_num_overlap_scans, *) num_overlap_scans

      scan_size = num_scans + num_overlap_scans * 2
      scan_start = 1 - num_overlap_scans
      scan_end = num_scans + num_overlap_scans

C     Scan Time
      status = AMTK_getDimSize(file_id, AM2_SCAN_TIME_DEF, dim_size)
      if (status.lt.0) then
          write(*,*) 'AMTK_getDimSize ERROR' ,status
          stop
      endif
      status = AMTK_getScanTime(file_id, scan_start,
     *    scan_end, scan_time)
      if (status.lt.0) then
          write(*,*) 'AMTK_getScanTime ERROR' ,status
          stop
      endif
      write(*,*) status
      Do scan_num =1, PRINT_SCAN_NUM
          write(*,'(8(A,I4,A))') 'Scan Time No=', scan_num,'  ',
     *        '[' ,scan_time( scan_num )%year,']  ',
     *        '[' ,scan_time( scan_num )%month,'/',
     *        ''  ,scan_time( scan_num )%day,  '] ',
     *        '[' ,scan_time( scan_num )%hour, ':',
     *        ''  ,scan_time( scan_num )%minute,':',
     *        ''  ,scan_time( scan_num )%second,'.',
     *        ''  ,scan_time( scan_num )%ms,']'
      End do

C     Position in Orbit
      status = AMTK_get_SwathDouble(file_id, pos_orbit, scan_start,
     *                                   scan_end, AM2_POS_ORBIT)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathDouble ERROR' ,status
          stop
      endif

C     Navigation Data
      status = AMTK_get_SwathFloat(file_id, navi, scan_start,
     *                                    scan_end, AM2_NAVI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Attitude Data
      status = AMTK_get_SwathFloat(file_id, att, scan_start,
     *                                    scan_end, AM2_ATT)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (res06,6.9GHz,V) ... (res06,89.0GHz,H)
      status = AMTK_get_SwathFloat(file_id, res06_tb06v, scan_start,
     *    scan_end, AM2_RES06_TB06V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb06h, scan_start,
     *    scan_end, AM2_RES06_TB06H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb07v, scan_start,
     *    scan_end, AM2_RES06_TB07V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb07h, scan_start,
     *    scan_end, AM2_RES06_TB07H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb10v, scan_start,
     *    scan_end, AM2_RES06_TB10V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb10h, scan_start,
     *    scan_end, AM2_RES06_TB10H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb18v, scan_start,
     *    scan_end, AM2_RES06_TB18V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb18h, scan_start,
     *    scan_end, AM2_RES06_TB18H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb23v, scan_start,
     *    scan_end, AM2_RES06_TB23V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb23h, scan_start,
     *    scan_end, AM2_RES06_TB23H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb36v, scan_start,
     *    scan_end, AM2_RES06_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb36h, scan_start,
     *    scan_end, AM2_RES06_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb89v, scan_start,
     *    scan_end, AM2_RES06_TB89V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res06_tb89h, scan_start,
     *    scan_end, AM2_RES06_TB89H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (res10,10.7GHz,V) ... (res10,89.0GHz,H)
      status = AMTK_get_SwathFloat(file_id, res10_tb10v, scan_start,
     *    scan_end, AM2_RES10_TB10V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb10h, scan_start,
     *    scan_end, AM2_RES10_TB10H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb18v, scan_start,
     *    scan_end, AM2_RES10_TB18V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb18h, scan_start,
     *    scan_end, AM2_RES10_TB18H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb23v, scan_start,
     *    scan_end, AM2_RES10_TB23V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb23h, scan_start,
     *    scan_end, AM2_RES10_TB23H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb36v, scan_start,
     *    scan_end, AM2_RES10_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb36h, scan_start,
     *    scan_end, AM2_RES10_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb89v, scan_start,
     *    scan_end, AM2_RES10_TB89V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res10_tb89h, scan_start,
     *    scan_end, AM2_RES10_TB89H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
     
C     Brightness Temperature (res23,18.7GHz,V) ... (res23,89.0GHz,H)
      status = AMTK_get_SwathFloat(file_id, res23_tb18v, scan_start,
     *    scan_end, AM2_RES23_TB18V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb18h, scan_start,
     *    scan_end, AM2_RES23_TB18H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb23v, scan_start,
     *    scan_end, AM2_RES23_TB23V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb23h, scan_start,
     *    scan_end, AM2_RES23_TB23H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb36v, scan_start,
     *    scan_end, AM2_RES23_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb36h, scan_start,
     *    scan_end, AM2_RES23_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb89v, scan_start,
     *    scan_end, AM2_RES23_TB89V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res23_tb89h, scan_start,
     *    scan_end, AM2_RES23_TB89H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (res36,36.5GHz,V) ... (res36,89.0GHz,H)
      status = AMTK_get_SwathFloat(file_id, res36_tb36v, scan_start,
     *    scan_end, AM2_RES36_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res36_tb36h, scan_start,
     *    scan_end, AM2_RES36_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res36_tb89v, scan_start,
     *    scan_end, AM2_RES36_TB89V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res36_tb89h, scan_start,
     *    scan_end, AM2_RES36_TB89H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature  (original,89GHz-A,V)
C     ... (original,89GHz-B,H)
      status = AMTK_get_SwathFloat(file_id, res89_tb89av, scan_start,
     *    scan_end, AM2_TB89AV)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res89_tb89ah, scan_start,
     *    scan_end, AM2_TB89AH)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res89_tb89bv, scan_start,
     *    scan_end, AM2_TB89BV)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, res89_tb89bh, scan_start,
     *    scan_end, AM2_TB89BH)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
      status = AMTK_getLatLon(file_id, latlon_89a, scan_start,
     *    scan_end, AM2_LATLON_89A)
      if (status.lt.0) then
          write(*,*) 'AMTK_getLatLon ERROR' ,status
          stop
      endif

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
      status = AMTK_getLatLon(file_id, latlon_89b, scan_start,
     *    scan_end, AM2_LATLON_89B)
      if (status.lt.0) then
          write(*,*) 'AMTK_getLatLon ERROR' ,status
          stop
      endif

C     Area Mean Height
      status = AMTK_get_SwathFloat(file_id, height, scan_start,
     *    scan_end, AM2_MEAN_HEIGHT)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
     
C     Sun Azimuth
      status = AMTK_get_SwathFloat(file_id, sun_azim, scan_start,
     *    scan_end, AM2_SUN_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Sun Elevation
      status = AMTK_get_SwathFloat(file_id, sun_elev, scan_start,
     *    scan_end, AM2_SUN_EL)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Incidence
      status = AMTK_get_SwathFloat(file_id, eth_inci, scan_start,
     *    scan_end, AM2_EARTH_INC)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Azimuth
      status = AMTK_get_SwathFloat(file_id, eth_azim, scan_start,
     *    scan_end, AM2_EARTH_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
 
C     Land_Ocean Flag 6 to 36
      status = AMTK_get_SwathInt(file_id, lof_low, scan_start,
     *    scan_end, AM2_LOF_RES_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Land_Ocean Flag 89
      status = AMTK_get_SwathInt(file_id, lof_high, scan_start,
     *    scan_end, AM2_LOF_RES_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Scan Data Quality
      status = AMTK_get_ScanDataQuality(file_id, scanqual, scan_start,
     *    scan_end, AM2_SCAN_QUAL)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_ScanDataQuality ERROR' ,status
          stop
      endif

C     Pixel Data Quality 6 to 36
      status = AMTK_get_SwathUChar(file_id, pixqual_low, scan_start,
     *    scan_end, AM2_PIX_QUAL_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     Pixel Data Quality 89
      status = AMTK_get_SwathUChar(file_id, pixqual_high, scan_start,
     *    scan_end, AM2_PIX_QUAL_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif


      Do scan_num =1, PRINT_SCAN_NUM

C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num

C     Brightness Temperature (res06,6.9GHz,V) ... (res06,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,6.9GHz,V)  = ',
     *            res06_tb06v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,6.9GHz,H)  = ',
     *            res06_tb06h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,7.3GHz,V)  = ',
     *            res06_tb07v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,7.3GHz,H)  = ',
     *            res06_tb07h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,10.7GHz,V) = ',
     *            res06_tb10v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,10.7GHz,H) = ',
     *            res06_tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,18.7GHz,V) = ',
     *            res06_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,18.7GHz,H) = ',
     *            res06_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,23.8GHz,V) = ',
     *            res06_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,23.8GHz,H) = ',
     *            res06_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,36.5GHz,V) = ',
     *            res06_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,36.5GHz,H) = ',
     *            res06_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,89.0GHz,V) = ',
     *            res06_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,89.0GHz,H) = ',
     *            res10_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res10,10.7GHz,V) ... (res10,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,10.7GHz,V) = ',
     *            res10_tb10v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,10.7GHz,H) = ',
     *            res10_tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,18.7GHz,V) = ',
     *            res10_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,18.7GHz,H) = ',
     *            res10_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,23.8GHz,V) = ',
     *            res10_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,23.8GHz,H) = ',
     *            res10_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,36.5GHz,V) = ',
     *            res10_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,36.5GHz,H) = ',
     *            res10_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,89.0GHz,V) = ',
     *            res10_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,89.0GHz,H) = ',
     *            res10_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res23,18.7GHz,V) ... (res23,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,18.7GHz,V) = ',
     *            res23_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,18.7GHz,H) = ',
     *            res23_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,23.8GHz,V) = ',
     *            res23_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,23.8GHz,H) = ',
     *            res23_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,36.5GHz,V) = ',
     *            res23_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,36.5GHz,H) = ',
     *            res23_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,89.0GHz,V) = ',
     *            res23_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,89.0GHz,H) = ',
     *            res23_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res36,36.5GHz,V) ... (res36,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res36,36.5GHz,V) = ',
     *            res36_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res36,36.5GHz,H) = ',
     *            res36_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res36,89.0GHz,V) = ',
     *            res36_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res36,89.0GHz,H) = ',
     *            res36_tb89h(pixel_num, scan_num)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_LO
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num

C     Brightness Temperature (res06,6.9GHz,V) ... (res06,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,6.9GHz,V)  = ',
     *            res06_tb06v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,6.9GHz,H)  = ',
     *            res06_tb06h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,7.3GHz,V)  = ',
     *            res06_tb07v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,7.3GHz,H)  = ',
     *            res06_tb07h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,10.7GHz,V) = ',
     *            res06_tb10v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,10.7GHz,H) = ',
     *            res06_tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,18.7GHz,V) = ',
     *            res06_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,18.7GHz,H) = ',
     *            res06_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,23.8GHz,V) = ',
     *            res06_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,23.8GHz,H) = ',
     *            res06_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,36.5GHz,V) = ',
     *            res06_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,36.5GHz,H) = ',
     *            res06_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res06,89.0GHz,V) = ',
     *            res06_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res06,89.0GHz,H) = ',
     *            res10_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res10,10.7GHz,V) ... (res10,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,10.7GHz,V) = ',
     *            res10_tb10v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,10.7GHz,H) = ',
     *            res10_tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,18.7GHz,V) = ',
     *            res10_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,18.7GHz,H) = ',
     *            res10_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,23.8GHz,V) = ',
     *            res10_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,23.8GHz,H) = ',
     *            res10_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,36.5GHz,V) = ',
     *            res10_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,36.5GHz,H) = ',
     *            res10_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res10,89.0GHz,V) = ',
     *            res10_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res10,89.0GHz,H) = ',
     *            res10_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res23,18.7GHz,V) ... (res23,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,18.7GHz,V) = ',
     *            res23_tb18v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,18.7GHz,H) = ',
     *            res23_tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,23.8GHz,V) = ',
     *            res23_tb23v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,23.8GHz,H) = ',
     *            res23_tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,36.5GHz,V) = ',
     *            res23_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,36.5GHz,H) = ',
     *            res23_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res23,89.0GHz,V) = ',
     *            res23_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res23,89.0GHz,H) = ',
     *            res23_tb89h(pixel_num, scan_num)
     
C     Brightness Temperature (res36,36.5GHz,V) ... (res36,89.0GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res36,36.5GHz,V) = ',
     *            res36_tb36v(pixel_num, scan_num),
     *        ' Brightness Temperature (res36,36.5GHz,H) = ',
     *            res36_tb36h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (res36,89.0GHz,V) = ',
     *            res36_tb89v(pixel_num, scan_num),
     *        ' Brightness Temperature (res36,89.0GHz,H) = ',
     *            res36_tb89h(pixel_num, scan_num)

C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
     
C     Brightness Temperature  (original,89GHz-A,V)
C     ... (original,89GHz-B,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (original,89GHz-A,V) = ',
     *            res89_tb89av(pixel_num, scan_num),
     *        ' Brightness Temperature (original,89GHz-A,H) = ',
     *            res89_tb89ah(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (original,89GHz-B,V) = ',
     *            res89_tb89bv(pixel_num, scan_num),
     *        ' Brightness Temperature (original,89GHz-B,H) = ',
     *            res89_tb89bh(pixel_num, scan_num)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num , ' Pixel = ',
     *        pixel_num

C     Brightness Temperature  (original,89GHz-A,V)
C     ... (original,89GHz-B,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (original,89GHz-A,V) = ',
     *            res89_tb89av(pixel_num, scan_num),
     *        ' Brightness Temperature (original,89GHz-A,H) = ',
     *            res89_tb89ah(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (original,89GHz-B,V) = ',
     *            res89_tb89bv(pixel_num, scan_num),
     *        ' Brightness Temperature (original,89GHz-B,H) = ',
     *            res89_tb89bh(pixel_num, scan_num)
     
      End do

C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
C     write(*,*) 'Latitude/Longitude of Observation Point for 89A'

      Do scan_num =1, PRINT_SCAN_NUM
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F4.2))')
     *        'Latitude = ', latlon_89a(pixel_num, scan_num)%lat,
     *        '  Longitude = ' , latlon_89a(pixel_num, scan_num)%lon
     
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F4.2))')
     *        'Latitude = ', latlon_89a(pixel_num, scan_num)%lat,
     *        '  Longitude = ' , latlon_89a(pixel_num, scan_num)%lon
      End do

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
C     write(*,*) 'Latitude/Longitude of Observation Point for 89B'
      
      Do scan_num =1, PRINT_SCAN_NUM
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F4.2))')
     *        'Latitude = ', latlon_89b(pixel_num, scan_num)%lat,
     *        '  Longitude = ', latlon_89b(pixel_num, scan_num)%lon
     
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F4.2))')
     *        'Latitude = ', latlon_89b(pixel_num, scan_num)%lat,
     *        '  Longitude = ', latlon_89b(pixel_num, scan_num)%lon
      End do

C     Land_Ocean Flag 6 to 36
      Do scan_num =1, PRINT_SCAN_NUM
C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 06GHz = ',
     *        lof_low(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 07GHz = ',
     *        lof_low(pixel_num, scan_num, 2)
          write(*,*) 'Land_Ocean Flag 10GHz = ',
     *        lof_low(pixel_num, scan_num, 3)
          write(*,*) 'Land_Ocean Flag 18GHz = ',
     *        lof_low(pixel_num, scan_num, 4)
          write(*,*) 'Land_Ocean Flag 23GHz = ',
     *        lof_low(pixel_num, scan_num, 5)
          write(*,*) 'Land_Ocean Flag 36GHz = ',
     *        lof_low(pixel_num, scan_num, 6)

C         last pixel
          pixel_num = AM2_DEF_SNUM_LO
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 06GHz = ',
     *        lof_low(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 07GHz = ',
     *        lof_low(pixel_num, scan_num, 2)
          write(*,*) 'Land_Ocean Flag 10GHz = ',
     *        lof_low(pixel_num, scan_num, 3)
          write(*,*) 'Land_Ocean Flag 18GHz = ',
     *        lof_low(pixel_num, scan_num, 4)
          write(*,*) 'Land_Ocean Flag 23GHz = ',
     *        lof_low(pixel_num, scan_num, 5)
          write(*,*) 'Land_Ocean Flag 36GHz = ',
     *        lof_low(pixel_num, scan_num, 6)
      End do
      
C     Land_Ocean Flag 89
      Do scan_num =1, PRINT_SCAN_NUM
C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 89AGHz = ',
     *        lof_high(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 89BGHz = ',
     *        lof_high(pixel_num, scan_num, 2)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 89AGHz = ',
     *        lof_high(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 89BGHz = ',
     *        lof_high(pixel_num, scan_num, 2)
      End do
      
      
C     HDF product file close (write mode)
      status = AMTK_closeH5(file_id)
      if (status.lt.0) then
          write(*,*) 'AMTK_closeH5 ERROR' ,status
          stop
      endif
      
      Write(*,*) 'L1R product read end'

      Stop
      End
      
