C*****************************************************************************
C*  Copyright (C) NEC Corporation 2010 All rights reserved.                  *
C*  File Name    : sample12_make_L1Rproduct.f                                *
C*  Abstract     : I/O toolkit sample program                                *
C*  Function List                                                            *
C*      main                         : Sample program main                   *
C*                                                                           *
C*  Author     NEC                                                           *
C*  Date       2011/03/01                                                    *
C*  Version    1.09                                                          *
C*  Notice                                                                   *
C*****************************************************************************
      Program main

      Implicit NONE

      include 'AMTK_f77.h'

      character*40 fname
      data fname/'../data/sample12_IOToolKit_l1r_f77.h5'/
      character*40 meta
      data meta/'../data/metadata_sample_L1R.txt'/

C     Scene Scan number
      integer SCENE_SCAN_NUM
      PARAMETER (SCENE_SCAN_NUM = 2000)
C     Overlap Scan Number
      integer OVERLAP_SCAN_NUM
      Parameter (OVERLAP_SCAN_NUM = 0)
C     Meta_data number maximum
      integer META_DATA_NUM_MAX
      PARAMETER (META_DATA_NUM_MAX = 200)
C     Number of Scans(Variable size)
      integer NUM_SCANS
      PARAMETER (NUM_SCANS = 2000)

C     Sample meta data read
      character*512 buffer
      integer*1 datax(512)
      
      character*512 label(4)
      integer*1 idx(512)
      integer*1 metadata_name(512)
      integer*1 max_size(512)
      integer*1 metadata_value(512)

      Integer file_id
      Integer meta_data_num
      Integer scan_num
      Integer pixel_num

      Integer status
      Integer size(3)
      Integer i
      Integer j
      equivalence(buffer, datax)
      equivalence(label(1), idx)
      equivalence(label(2), metadata_name)
      equivalence(label(3), max_size)
      equivalence(label(4), metadata_value)

      Integer lines
      Integer scan_size
      Integer scan_start
      Integer scan_end
      
      character*3 buf_itoa
      Integer param

C--------------------------------------------------------------------C
C    *definition of data set variable.                               C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C    *Scan Time
      COMMON /scan_time/ scan_time
      character*24 scan_time(NUM_SCANS)
      
C    *Position in Orbit
      Real*8 pos_orbit(NUM_SCANS)

C    *Navigation Data
      Real navi(6, NUM_SCANS)

C    *Attitude Data
      Real att(3, NUM_SCANS)

C    *Brightness Temperature <06GHz resolution>
      Real res06_tb06v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb06h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb07v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb07h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb10v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb10h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res06_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Brightness Temperature <10GHz resolution>
      Real res10_tb10v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb10h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res10_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Brightness Temperature <23GHz resolution>
      Real res23_tb18v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb18h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb23v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb23h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res23_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS)
      
C    *Brightness Temperature <36GHz resolution>
      Real res36_tb36v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res36_tb36h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res36_tb89v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real res36_tb89h(AM2_DEF_SNUM_LO, NUM_SCANS)
      
C    *Brightness Temperature <89GHz resolution>
      Real res89_tb89av(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real res89_tb89ah(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real res89_tb89bv(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real res89_tb89bh(AM2_DEF_SNUM_HI, NUM_SCANS)
      
C    *Latitude of Observation Point for 89A
C    *Longitude of Observation Point for 89A
      COMMON /latlon_89a/ latlon_89a
      character*8 latlon_89a( AM2_DEF_SNUM_HI, NUM_SCANS )

C    *Latitude of Observation Point for 89B
C    *Longitude of Observation Point for 89B
      COMMON /latlon_89b/ latlon_89b
      character*8 latlon_89b( AM2_DEF_SNUM_HI, NUM_SCANS )

C    *Area Mean Height
      Real height(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Sun Azimuth
      Real sun_azim(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Sun Elevation
      Real sun_elev(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Earth Incidence
      Real eth_inci(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Earth Azimuth
      Real eth_azim(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Land_Ocean Flag 6 to 36
      Integer lof_low(AM2_DEF_SNUM_LO, NUM_SCANS, 6)

C    *Land_Ocean Flag 89
      Integer lof_high(AM2_DEF_SNUM_HI, NUM_SCANS, 2)

C    *Scan Data Quality
      COMMON /scanqual/ scanqual
      character*512 scanqual(NUM_SCANS)

C    *Pixel Data Quality 6 to 36
C    *(Numbef of scans * 486[243 * binary 2byte])
      Character pixqual_low(AM2_DEF_SNUM_LO * 2, NUM_SCANS)

C    *Pixel Data Quality 89
C    *(Numbef of scans * 486[486 * binary 1byte])
      Character pixqual_high(AM2_DEF_SNUM_HI * 1, NUM_SCANS)

C--------------------------------------------------------------------C
C    *init data set                                                  C
C--------------------------------------------------------------------C

      scan_size = SCENE_SCAN_NUM + OVERLAP_SCAN_NUM * 2
      scan_start = 1 - OVERLAP_SCAN_NUM
      scan_end = SCENE_SCAN_NUM + OVERLAP_SCAN_NUM
      
      param = AM2_CREATE_MODE
      
C     HDF product file open (write mode)
      file_id = AMTK_openH5_Write(fname, param)
      if (file_id.lt.0) then
          write(*,*) 'AMTK_openH5_Write ERROR' ,file_id
          stop
      endif
      
C     sample meta data read
C     Read Metadata from Metadata file

      lines = 0
      
      open(10, file=meta, status='old')

  555 read(10, 100, end=999) buffer
  100 format(A512)
c
      lines = lines + 1
c
      do i=1,512
          idx(i) = 32
          metadata_name(i) = 32
          max_size(i) = 32
          metadata_value(i) = 32
      end do
c
      i=1
      j=1
   10 if( datax(i).ne.9 ) then
          idx(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 10
      endif
c
      i=i+1
      j=1
   20 if( datax(i).ne.9 ) then
          metadata_name(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 20
      endif
c
      i=i+1
      j=1
   30 if( datax(i).ne.9 ) then
          max_size(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 30
      endif
c
      i=i+1
      j=1
   40 if( i.lt.512 .and. datax(i).ne.0 .and. datax(i).ne.9) then
          metadata_value(j) = datax(i)
          i = i + 1
          j = j + 1
          goto 40
      endif
c

C     Meta data write
      status = AMTK_setMetaDataName(file_id, label(2), label(4))
      if (status.lt.0) then
          write(*,*) 'AMTK_setMetaDataName ERROR' ,status
          close(10)
          stop
      endif
      goto 555

  999 meta_data_num = lines

      close(10)


      Do scan_num =1, scan_size

C    *    Scan Time
          AM2_COMMON_SCANTIME = scan_time(scan_num)
          year = 2010
          month = MOD((scan_num - 1), 12)
          if(month.eq.0) then
              month = 1
          endif
          day = MOD((scan_num - 1), 28)
          if(day.eq.0) then
              day = 1
          endif
          hour = MOD((scan_num - 1), 24)
          minute = MOD((scan_num - 1), 60)
          second = MOD((scan_num - 1), 60)
          ms = MOD((scan_num - 1), 100)
          scan_time(scan_num) = AM2_COMMON_SCANTIME
          
C    *    Position in Orbit
          pos_orbit(scan_num) = 0.001 * scan_num
          
C    *    Navigation Data
          Do i =1, 6
              navi(i, scan_num) = 0.001 * scan_num + 1
          End Do

C    *    Attitude Data
          Do i =1, 3
              att(i, scan_num) = 0.001 * scan_num + 1
          End Do

          Do pixel_num =1, AM2_DEF_SNUM_LO
          
C    *        Brightness Temperature (res06,6.9GHz,V)
C    *        ... (res06,89.0GHz,H)
              res06_tb06v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb06h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb07v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb07h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb10v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb10h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb18v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb18h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb23v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb23h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb36v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb36h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb89v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res06_tb89h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              
C    *        Brightness Temperature (res10,10.7GHz,V)
C    *        ... (res10,89.0GHz,H)
              res10_tb10v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb10h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb18v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb18h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb23v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb23h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb36v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb36h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb89v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res10_tb89h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              
C    *        Brightness Temperature (res23,18.7GHz,V)
C    *        ... (res23,89.0GHz,H)
              res23_tb18v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb18h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb23v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb23h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb36v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb36h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb89v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res23_tb89h(pixel_num, scan_num) = 0.01 * (pixel_num-1)

C    *        Brightness Temperature (res36,36.5GHz,V)
C    *        ... (res36,89.0GHz,H)
              res36_tb36v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res36_tb36h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res36_tb89v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res36_tb89h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              
C    *        Area Mean Height
              height(pixel_num, scan_num) = (pixel_num-1)
              
C    *        Sun Azimuth
              sun_azim(pixel_num, scan_num) = (pixel_num-1)
              
C    *        Sun Elevation
              sun_elev(pixel_num, scan_num) = (pixel_num-1)

C    *        Earth Incidence
              eth_inci(pixel_num, scan_num) = (pixel_num-1)

C    *        Earth Azimuth
              eth_azim(pixel_num, scan_num) = (pixel_num-1)

C    *        Land_Ocean Flag 6 to 36
              Do i =1, 6
                  lof_low(pixel_num, scan_num, i) =
     *                MOD(scan_num + pixel_num + i, 256)
              End Do
          
          End do
          
          Do pixel_num =1, AM2_DEF_SNUM_HI
          
C    *        Brightness Temperature (original,89GHz-A,V)
C    *        ... (original,89GHz-B,H)
              res89_tb89av(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res89_tb89ah(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res89_tb89bv(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              res89_tb89bh(pixel_num, scan_num) = 0.01 * (pixel_num-1)

C    *        Latitude of Observation Point for 89A
C    *        Longitude of Observation Point for 89A
              AM2_COMMON_LATLON = latlon_89a(pixel_num, scan_num)
              lat = REAL(MOD((pixel_num - 1) - 90, 91))
              lon = REAL(MOD((pixel_num - 1) - 180, 181))
              latlon_89a(pixel_num, scan_num) = AM2_COMMON_LATLON

C    *        Latitude of Observation Point for 89B
C    *        Longitude of Observation Point for 89B
              AM2_COMMON_LATLON = latlon_89b(pixel_num, scan_num)
              lat = REAL(MOD((pixel_num - 1) - 89, 91))
              lon = REAL(MOD((pixel_num - 1) - 179, 181))
              latlon_89b(pixel_num, scan_num) = AM2_COMMON_LATLON

C    *        Land_Ocean Flag 89
              Do i =1, 2
                  lof_high(pixel_num, scan_num, i) =
     *                MOD(scan_num + pixel_num + i, 256)
              End Do

              buf_itoa = CHAR(MOD(scan_num, 256))
              
C    *        Pixel Data Quality 6 to 36
              pixqual_low(pixel_num, scan_num) = buf_itoa

C    *        Pixel Data Quality 89
              pixqual_high(pixel_num, scan_num) = buf_itoa

          End do
          
      End do


C--------------------------------------------------------------------C
C    *output data                                                    C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C     Scan Time
      size(1) = scan_size
      size(2) = 0
      size(3) = 0
      param = AM2_SCAN_TIME_DEF
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setScanTime(file_id, scan_time,
     *    scan_start, scan_end)
      if (status.lt.0) then
          write(*,*) 'AMTK_setScanTime ERROR' ,status
          stop
      endif
      
C     Position in Orbit
      size(1) = scan_size
      size(2) = 0
      size(3) = 0
      param = AM2_POS_ORBIT
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathDouble(file_id, pos_orbit, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathDouble ERROR' ,status
          stop
      endif

C     Navigation Data
      size(1) = scan_size
      size(2) = 6
      size(3) = 0
      param = AM2_NAVI
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, navi, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Attitude Data
      size(1) = scan_size
      size(2) = 3
      size(3) = 0
      param = AM2_ATT
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, att, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (res06,6.9GHz,V) ... (res06,89.0GHz,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_RES06_TB06V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb06v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB06H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb06h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB07V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb07v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB07H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb07h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB10V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb10v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB10H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb10h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB18V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb18v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB18H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb18h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB23V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb23v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB23H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb23h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB36V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb36v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB36H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb36h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB89V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb89v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES06_TB89H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res06_tb89h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature (res10,10.7GHz,V) ... (res10,89.0GHz,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_RES10_TB10V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb10v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB10H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb10h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB18V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb18v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB18H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb18h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB23V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb23v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB23H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb23h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB36V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb36v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB36H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb36h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB89V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb89v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES10_TB89H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res10_tb89h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature (res23,18.7GHz,V) ... (res23,89.0GHz,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_RES23_TB18V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb18v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB18H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb18h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB23V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb23v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB23H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb23h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB36V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb36v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB36H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb36h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB89V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb89v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES23_TB89H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res23_tb89h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature (res36,36.5GHz,V) ... (res36,89.0GHz,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_RES36_TB36V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res36_tb36v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES36_TB36H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res36_tb36h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES36_TB89V
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res36_tb89v, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_RES36_TB89H
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res36_tb89h, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature  (original,89GHz-A,V)
C     ... (original,89GHz-B,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      param = AM2_TB89AV
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res89_tb89av, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_TB89AH
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res89_tb89ah, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_TB89BV
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res89_tb89bv, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      param = AM2_TB89BH
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, res89_tb89bh, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      

C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      param = AM2_LATLON_89A
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setLatLon(file_id, latlon_89a, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_setLatLon ERROR' ,status
          stop
      endif
      

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      param = AM2_LATLON_89B
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setLatLon(file_id, latlon_89b, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_setLatLon ERROR' ,status
          stop
      endif
      

C     Area Mean Height
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_MEAN_HEIGHT
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, height, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      

C     Sun Azimuth
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_SUN_AZ
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, sun_azim, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      

C     Sun Elevation
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_SUN_EL
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, sun_elev, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      

C     Earth Incidence
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_EARTH_INC
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, eth_inci, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      

C     Earth Azimuth
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      param = AM2_EARTH_AZ
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, eth_azim, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
 
C     Land_Ocean Flag 6 to 36
      size(1) = 6
      size(2) = scan_size
      size(3) = AM2_DEF_SNUM_LO
      param = AM2_LOF_RES_LO
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, lof_low, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      

C     Land_Ocean Flag 89
      size(1) = 2
      size(2) = scan_size
      size(3) = AM2_DEF_SNUM_HI
      param = AM2_LOF_RES_HI
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, lof_high, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      

C     Scan Data Quality
      size(1) = scan_size
      size(2) = 512
      size(3) = 0
      param = AM2_SCAN_QUAL
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_ScanDataQuality(file_id, scanqual, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_ScanDataQuality ERROR' ,status
          stop
      endif
      

C     Pixel Data Quality 6 to 36
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO * 2
      size(3) = 0
      param = AM2_PIX_QUAL_LO
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, pixqual_low, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif
      

C     Pixel Data Quality 89
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI * 1
      size(3) = 0
      param = AM2_PIX_QUAL_HI
      status = AMTK_setDimSize(file_id, param, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, pixqual_high, scan_start,
     *    scan_end, param)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif
      

C     HDF product file close (write mode)
      status = AMTK_closeH5_Write(file_id)
      if (status.lt.0) then
          write(*,*) 'AMTK_closeH5_Write ERROR' ,status
          stop
      endif
      
      Write(*,*) 'L1R product created'

      Stop
      End


