C*****************************************************************************
C*  Copyright (C) NEC Corporation 2010 All rights reserved.                  *
C*  File Name    : sample2_make_L1Bproduct.f                                 *
C*  Abstract     : I/O toolkit sample program                                *
C*  Function List                                                            *
C*      main                         : Sample program main                   *
C*                                                                           *
C*  Author     NEC                                                           *
C*  Date       2011/03/01                                                    *
C*  Version    1.09                                                          *
C*  Notice                                                                   *
C*****************************************************************************
      Program main

      Implicit NONE

      include 'AMTK_f77.h'

      character*40 fname
      data fname/'../data/sample2_IOToolKit_l1b_f77.h5'/
      character*40 meta
      data meta/'../data/metadata_sample_L1B.txt'/

C     Scene Scan number
      integer SCENE_SCAN_NUM
      PARAMETER (SCENE_SCAN_NUM=2000)
C     Overlap Scan Number
      integer OVERLAP_SCAN_NUM
      PARAMETER (OVERLAP_SCAN_NUM=20)
C     Meta_data number maximum
      integer META_DATA_NUM_MAX
      PARAMETER (META_DATA_NUM_MAX=200)
C     Number of Scans
      integer NUM_SCANS
      PARAMETER (NUM_SCANS=2040)
      
C     Sample meta data read
      character*512 buffer
      integer*1 datax(512)
      
      character*512 label(4)
      integer*1 idx(512)
      integer*1 metadata_name(512)
      integer*1 max_size(512)
      integer*1 metadata_value(512)

      Integer file_id
      Integer meta_data_num
      Integer scan_num
      Integer pixel_num

      Integer status
      Integer size(3)
      Integer i
      Integer j
      equivalence(buffer, datax)
      equivalence(label(1), idx)
      equivalence(label(2), metadata_name)
      equivalence(label(3), max_size)
      equivalence(label(4), metadata_value)

      Integer lines
      Integer scan_size
      Integer scan_start
      Integer scan_end

      character*3 buf_itoa

C--------------------------------------------------------------------C
C    *definition of data set variable.                               C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C    *Scan Time
      COMMON /scan_time/ scan_time
      character*24 scan_time(NUM_SCANS)
      
C    *Position in Orbit
      Real*8 pos_orbit(NUM_SCANS)

C    *Navigation Data
      Real navi(6, NUM_SCANS)

C    *Attitude Data
      Real att(3, NUM_SCANS)

C    *Brightness Temperature
      Real tb06v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb06h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb07v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb07h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb10v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb10h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb18v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb18h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb23v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb23h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb36v(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb36h(AM2_DEF_SNUM_LO, NUM_SCANS)
      Real tb89av(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real tb89ah(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real tb89bv(AM2_DEF_SNUM_HI, NUM_SCANS)
      Real tb89bh(AM2_DEF_SNUM_HI, NUM_SCANS)

C    *Hot Load Count 6 to 36
      Integer hts_low(16, NUM_SCANS, 12)

C    *Hot Load Count 89
      Integer hts_high(32, NUM_SCANS, 4)

C    *Cold Sky Mirror Count 6 to 36
      Integer csm_low(16, NUM_SCANS, 12)

C    *Cold Sky Mirror Count 89
      Integer csm_high(32, NUM_SCANS, 4)

C    *Rx Offset_Gain Count
      Integer rx_offgain(32, NUM_SCANS)

C    *Latitude of Observation Point for 89A
C    *Longitude of Observation Point for 89A
      COMMON /latlon_89a/ latlon_89a
      character*8 latlon_89a(AM2_DEF_SNUM_HI, NUM_SCANS)
      
C    *Latitude of Observation Point for 89B
C    *Longitude of Observation Point for 89B
      COMMON /latlon_89b/ latlon_89b
      character*8 latlon_89b(AM2_DEF_SNUM_HI, NUM_SCANS)
      
C    *Sun Azimuth
      Real sun_azim(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Sun Elevation
      Real sun_elev(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Earth Incidence
      Real eth_inci(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Earth Azimuth
      Real eth_azim(AM2_DEF_SNUM_LO, NUM_SCANS)

C    *Land_Ocean Flag 6 to 36
      Integer lof_low(AM2_DEF_SNUM_LO, NUM_SCANS, 6)

C    *Land_Ocean Flag 89
      Integer lof_high(AM2_DEF_SNUM_HI, NUM_SCANS, 2)

C    *Observation Supplement
C    *(Numbef of scans * 248[124 * binary 2byte])
      Character obs_spl(248, NUM_SCANS)

C    *SPC Temperature Count
      Real spc_temp(34, NUM_SCANS)

C    *SPS Temperature Count
      Real sps_temp(46, NUM_SCANS)

C    *PCD Data
      Character pcd_data(64, NUM_SCANS)

C    *Scan Data Quality
      COMMON /scanqual/ scanqual
      character*512 scanqual(NUM_SCANS)

C    *Pixel Data Quality 6 to 36
C    *(Numbef of scans * 486[243 * binary 2byte])
      Character pixqual_low(AM2_DEF_SNUM_LO * 2, NUM_SCANS)

C    *Pixel Data Quality 89
C    *(Numbef of scans * 486[486 * binary 1byte])
      Character pixqual_high(AM2_DEF_SNUM_HI * 1, NUM_SCANS)

C    *Interpolation Flag 6 to 36
      Character intpol_low(16, NUM_SCANS, 12)

C    *Interpolation Flag 89
      Character intpol_high(32, NUM_SCANS, 4)


C--------------------------------------------------------------------C
C    *init data set                                                  C
C--------------------------------------------------------------------C

      scan_size = SCENE_SCAN_NUM + OVERLAP_SCAN_NUM * 2
      scan_start = 1 - OVERLAP_SCAN_NUM
      scan_end = SCENE_SCAN_NUM + OVERLAP_SCAN_NUM

C     HDF product file open (write mode)
      file_id = AMTK_openH5_Write(fname, AM2_CREATE_MODE)
      if (file_id.lt.0) then
          write(*,*) 'AMTK_openH5_Write ERROR' ,file_id
          stop
      endif
      
C     sample meta data read
C     Read Metadata from Metadata file

      lines = 0
      
      open(10, file=meta, status='old')

  555 read(10, 100, end=999) buffer
  100 format(A512)
c
      lines = lines + 1
c
      do i=1,512
          idx(i) = 32
          metadata_name(i) = 32
          max_size(i) = 32
          metadata_value(i) = 32
      end do
c
      i=1
      j=1
   10 if( datax(i).ne.9 ) then
          idx(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 10
      endif
c
      i=i+1
      j=1
   20 if( datax(i).ne.9 ) then
          metadata_name(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 20
      endif
c
      i=i+1
      j=1
   30 if( datax(i).ne.9 ) then
          max_size(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 30
      endif
c
      i=i+1
      j=1
   40 if( i.lt.512 .and. datax(i).ne.0 .and. datax(i).ne.9) then
          metadata_value(j) = datax(i)
          i = i + 1
          j = j + 1
          goto 40
      endif
c

C     Meta data write
      status = AMTK_setMetaDataName(file_id, label(2), label(4))
      if (status.lt.0) then
          write(*,*) 'AMTK_setMetaDataName ERROR' ,status
          close(10)
          stop
      endif
      goto 555

  999 meta_data_num = lines

      close(10)


      Do scan_num =1, scan_size

C    *    Scan Time
          AM2_COMMON_SCANTIME = scan_time(scan_num)
          year = 2010
          month = MOD((scan_num - 1), 12)
          if(month.eq.0) then
              month = 1
          endif
          day = MOD((scan_num - 1), 28)
          if(day.eq.0) then
              day = 1
          endif
          hour = MOD((scan_num - 1), 24)
          minute = MOD((scan_num - 1), 60)
          second = MOD((scan_num - 1), 60)
          ms = MOD((scan_num - 1), 100)
          scan_time(scan_num) = AM2_COMMON_SCANTIME
          
C    *    Position in Orbit
          pos_orbit(scan_num) = 0.001 * scan_num
          
C    *    Navigation Data
          Do i =1, 6
              navi(i, scan_num) = 0.001 * scan_num + 1
          End Do

C    *    Attitude Data
          Do i =1, 3
              att(i, scan_num) = 0.001 * scan_num + 1
          End Do

          Do pixel_num =1, AM2_DEF_SNUM_LO
          
C    *        Brightness Temperature (6.9GHz,V) ... (36.5GHz,H)
              tb06v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb06h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb07v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb07h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb10v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb10h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb18v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb18h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb23v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb23h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb36v(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb36h(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              
C    *        Sun Azimuth
              sun_azim(pixel_num, scan_num) = (pixel_num-1)
              
C    *        Sun Elevation
              sun_elev(pixel_num, scan_num) = (pixel_num-1)

C    *        Earth Incidence
              eth_inci(pixel_num, scan_num) = (pixel_num-1)

C    *        Earth Azimuth
              eth_azim(pixel_num, scan_num) = (pixel_num-1)

C    *        Land_Ocean Flag 6 to 36
              Do i =1, 6
                  lof_low(pixel_num, scan_num, i) =
     *                mod(scan_num + pixel_num + i, 256)
              End Do
          
          End do
          
          Do pixel_num =1, AM2_DEF_SNUM_HI
          
C    *        Brightness Temperature (89GHz-A,V) ... (89GHz-B,H)
              tb89av(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb89ah(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb89bv(pixel_num, scan_num) = 0.01 * (pixel_num-1)
              tb89bh(pixel_num, scan_num) = 0.01 * (pixel_num-1)

C    *        Latitude of Observation Point for 89A
C    *        Longitude of Observation Point for 89A
              AM2_COMMON_LATLON = latlon_89a(pixel_num, scan_num)
              lat = REAL(MOD((pixel_num - 1) - 90, 91))
              lon = REAL(MOD((pixel_num - 1) - 180, 181))
              latlon_89a(pixel_num, scan_num) = AM2_COMMON_LATLON

C    *        Latitude of Observation Point for 89B
C    *        Longitude of Observation Point for 89B
              AM2_COMMON_LATLON = latlon_89b(pixel_num, scan_num)
              lat = REAL(MOD((pixel_num - 1) - 89, 91))
              lon = REAL(MOD((pixel_num - 1) - 179, 181))
              latlon_89b(pixel_num, scan_num) = AM2_COMMON_LATLON

C    *        Land_Ocean Flag 89
              Do i =1, 2
                  lof_high(pixel_num, scan_num, i) =
     *                mod(scan_num + pixel_num + i, 256)
              End Do

              buf_itoa = char(mod(scan_num, 256))
              
C    *        Pixel Data Quality 6 to 36
              pixqual_low(pixel_num, scan_num) = buf_itoa

C    *        Pixel Data Quality 89
              pixqual_high(pixel_num, scan_num) = buf_itoa

          End do
          
      End do


C--------------------------------------------------------------------C
C    *output data                                                    C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C     Scan Time
      size(1) = scan_size
      size(2) = 0
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SCAN_TIME_DEF, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setScanTime(file_id, scan_time,
     *    scan_start, scan_end)
      if (status.lt.0) then
          write(*,*) 'AMTK_setScanTime ERROR' ,status
          stop
      endif

C     Position in Orbit
      size(1) = scan_size
      size(2) = 0
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_POS_ORBIT, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathDouble(file_id, pos_orbit, scan_start,
     *    scan_end, AM2_POS_ORBIT)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathDouble ERROR' ,status
          stop
      endif

C     Navigation Data
      size(1) = scan_size
      size(2) = 6
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_NAVI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, navi, scan_start,
     *    scan_end, AM2_NAVI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Attitude Data
      size(1) = scan_size
      size(2) = 3
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_ATT, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, att, scan_start,
     *    scan_end, AM2_ATT)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (6.9GHz,V) ... (36.5GHz,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_TB06V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb06v, scan_start,
     *    scan_end, AM2_TB06V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB06H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb06h, scan_start,
     *    scan_end, AM2_TB06H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB07V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb07v, scan_start,
     *    scan_end, AM2_TB07V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB07H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb07h, scan_start,
     *    scan_end, AM2_TB07H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB10V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb10v, scan_start,
     *    scan_end, AM2_TB10V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB10H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb10h, scan_start,
     *    scan_end, AM2_TB10H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB18V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb18v, scan_start,
     *    scan_end, AM2_TB18V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB18H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb18h, scan_start,
     *    scan_end, AM2_TB18H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB23V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb23v, scan_start,
     *    scan_end, AM2_TB23V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB23H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb23h, scan_start,
     *    scan_end, AM2_TB23H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB36V, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb36v, scan_start,
     *    scan_end, AM2_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB36H, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb36h, scan_start,
     *    scan_end, AM2_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature (89GHz-A,V) ... (89GHz-B,H)
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_TB89AV, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb89av, scan_start,
     *    scan_end, AM2_TB89AV)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB89AH, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb89ah, scan_start,
     *    scan_end, AM2_TB89AH)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB89BV, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb89bv, scan_start,
     *    scan_end, AM2_TB89BV)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
      status = AMTK_setDimSize(file_id, AM2_TB89BH, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, tb89bh, scan_start,
     *    scan_end, AM2_TB89BH)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif
      
C     Hot Load Count 6 to 36
      size(1) = 12
      size(2) = scan_size
      size(3) = 16
      status = AMTK_setDimSize(file_id, AM2_HTS_LO, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, hts_low, scan_start,
     *    scan_end, AM2_HTS_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      
C     Hot Loat Count 89
      size(1) = 4
      size(2) = scan_size
      size(3) = 32
      status = AMTK_setDimSize(file_id, AM2_HTS_HI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, hts_high, scan_start,
     *    scan_end, AM2_HTS_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      
C     Cold Sky Mirror Count 6 to 36
      size(1) = 12
      size(2) = scan_size
      size(3) = 16
      status = AMTK_setDimSize(file_id, AM2_CSM_LO, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, csm_low, scan_start,
     *    scan_end, AM2_CSM_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      
C     Cold Sky Mirror Count 89
      size(1) = 4
      size(2) = scan_size
      size(3) = 32
      status = AMTK_setDimSize(file_id, AM2_CSM_HI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, csm_high, scan_start,
     *    scan_end, AM2_CSM_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      
C     Rx Offset_Gain Count
      size(1) = scan_size
      size(2) = 32
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_OFF_GAIN, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, rx_offgain, scan_start,
     *    scan_end, AM2_OFF_GAIN)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif
      
C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_LATLON_89A, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setLatLon(file_id, latlon_89a, scan_start,
     *    scan_end, AM2_LATLON_89A)
      if (status.lt.0) then
          write(*,*) 'AMTK_setLatLon ERROR' ,status
          stop
      endif
      

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_LATLON_89B, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_setLatLon(file_id, latlon_89b, scan_start,
     *    scan_end, AM2_LATLON_89B)
      if (status.lt.0) then
          write(*,*) 'AMTK_setLatLon ERROR' ,status
          stop
      endif

C     Sun Azimuth
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SUN_AZ, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, sun_azim, scan_start,
     *    scan_end, AM2_SUN_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Sun Elevation
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SUN_EL, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, sun_elev, scan_start,
     *    scan_end, AM2_SUN_EL)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Incidence
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_EARTH_INC, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, eth_inci, scan_start,
     *    scan_end, AM2_EARTH_INC)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Azimuth
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_EARTH_AZ, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, eth_azim, scan_start,
     *    scan_end, AM2_EARTH_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     Land_Ocean Flag 6 to 36
      size(1) = 6
      size(2) = scan_size
      size(3) = AM2_DEF_SNUM_LO
      status = AMTK_setDimSize(file_id, AM2_LOF_LO, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, lof_low, scan_start,
     *    scan_end, AM2_LOF_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif

C     Land_Ocean Flag 89
      size(1) = 2
      size(2) = scan_size
      size(3) = AM2_DEF_SNUM_HI
      status = AMTK_setDimSize(file_id, AM2_LOF_HI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathInt(file_id, lof_high, scan_start,
     *    scan_end, AM2_LOF_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathInt ERROR' ,status
          stop
      endif

C     Observation Supplement
      size(1) = scan_size
      size(2) = 124 * 2
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_OB_SPL, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, obs_spl, scan_start,
     *    scan_end, AM2_OB_SPL)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif

C     SPC Temperature Count
      size(1) = scan_size
      size(2) = 34
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SPC_TEMP, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, spc_temp, scan_start,
     *    scan_end, AM2_SPC_TEMP)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     SPS Temperature Count
      size(1) = scan_size
      size(2) = 46
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SPS_TEMP, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathFloat(file_id, sps_temp, scan_start,
     *    scan_end, AM2_SPS_TEMP)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathFloat ERROR' ,status
          stop
      endif

C     PCD Data
      size(1) = scan_size
      size(2) = 64
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_PCD, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, pcd_data, scan_start,
     *    scan_end, AM2_PCD)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif

C     Scan Data Quality
      size(1) = scan_size
      size(2) = 512
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_SCAN_QUAL, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_ScanDataQuality(file_id, scanqual, scan_start,
     *    scan_end, AM2_SCAN_QUAL)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_ScanDataQuality ERROR' ,status
          stop
      endif

C     Pixel Data Quality 6 to 36
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_LO * 2
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_PIX_QUAL_LO, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, pixqual_low, scan_start,
     *    scan_end, AM2_PIX_QUAL_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif

C     Pixel Data Quality 89
      size(1) = scan_size
      size(2) = AM2_DEF_SNUM_HI * 1
      size(3) = 0
      status = AMTK_setDimSize(file_id, AM2_PIX_QUAL_HI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, pixqual_high, scan_start,
     *    scan_end, AM2_PIX_QUAL_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif

C     Interpolation Flag 6 to 36
      size(1) = 12
      size(2) = scan_size
      size(3) = 16
      status = AMTK_setDimSize(file_id, AM2_INTPL_LO, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, intpol_low, scan_start,
     *    scan_end, AM2_INTPL_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif
      
C     Interpolation Flag 89
      size(1) = 4
      size(2) = scan_size
      size(3) = 32
      status = AMTK_setDimSize(file_id, AM2_INTPL_HI, size)
      if (status.lt.0) then
          write(*,*) 'AMTK_setDimSize ERROR' ,status
          stop
      endif
      status = AMTK_set_SwathUChar(file_id, intpol_high, scan_start,
     *    scan_end, AM2_INTPL_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_set_SwathUChar ERROR' ,status
          stop
      endif
      
C     HDF product file close (write mode)
      status = AMTK_closeH5_Write(file_id)
      if (status.lt.0) then
          write(*,*) 'AMTK_closeH5_Write ERROR' ,status
          stop
      endif

      Write(*,*) 'L1B product created'

      Stop
      End


