C*****************************************************************************
C*  Copyright (C) NEC Corporation 2010 All rights reserved.                  *
C*  File Name    : sample7_read_L1Bproduct.f                                 *
C*  Abstract     : I/O toolkit sample program                                *
C*  Function List                                                            *
C*      main                         : Sample program main                   *
C*                                                                           *
C*  Author     NEC                                                           *
C*  Date       2011/02/01                                                    *
C*  Version    1.08                                                          *
C*  Notice                                                                   *
C*****************************************************************************
      Program main

      Implicit NONE

      include 'AMTK_f77.h'


C     PRINT_SCAN_NUM defines print data number
      Integer PRINT_SCAN_NUM
      PARAMETER (PRINT_SCAN_NUM = 2)
C     Number of Scans(Variable size)
      Integer NUM_SCANS_VAR
      PARAMETER (NUM_SCANS_VAR = 2040)

      character*40 fname
      data fname/'../data/sample2_IOToolKit_l1b_f77.h5'/
      character*40 meta
      data meta/'../data/metadata_sample_L1B.txt'/

C     Sample meta data read
      character*512 buffer
      integer*1 datax(512)
      
      character*512  label(4)
      integer*1 idx(512)
      integer*1 metadata_name(512)
      integer*1 max_size(512)
      integer*1 metadata_value(512)

      character*1024 metadata_area_buff
      integer*1 metadata_area(1024)
      equivalence(metadata_area_buff, metadata_area)
c

      Integer file_id
      Integer meta_data_num
      Integer scan_num
      Integer pixel_num

      Integer status
      Integer i
      Integer j
      equivalence(buffer, datax)
      equivalence(label(1), idx)
      equivalence(label(2), metadata_name)
      equivalence(label(3), max_size)
      equivalence(label(4), metadata_value)

      Integer dim_size(3)

      Integer lines
      Integer scan_size
      Integer scan_start
      Integer scan_end

      Integer num_scans
      Integer num_overlap_scans
      Character*4 buf_num_scans
      Character*2 buf_num_overlap_scans

C--------------------------------------------------------------------C
C    *definition of data set variable.                               C
C--------------------------------------------------------------------C

C     Dimension size <-> Array size
C     Elements of the array is reversed.
C      Example)
C       AMTK_getDimSize(*, *, dim_size)
C       dim_size(1) : Scan
C       dim_size(2) : Pixel
C       dim_size(3) : Layer
C       -> array(Layer, Pixel, Scan)

C    *Scan Time
      COMMON /scan_time/ scan_time
      character*24 scan_time(NUM_SCANS_VAR)

C    *Position in Orbit
      Real*8 pos_orbit(NUM_SCANS_VAR)

C    *Navigation Data
      Real navi(6, NUM_SCANS_VAR)

C    *Attitude Data
      Real att(3, NUM_SCANS_VAR)

C    *Brightness Temperature
      Real tb06v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb06h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb07v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb07h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb10v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb10h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb18v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb18h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb23v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb23h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb36v(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb36h(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)
      Real tb89av(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real tb89ah(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real tb89bv(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      Real tb89bh(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)
      
C    *Hot Load Count 6 to 36
      Integer hts_low(16, NUM_SCANS_VAR, 12)

C    *Hot Load Count 89
      Integer hts_high(32, NUM_SCANS_VAR, 4)

C    *Cold Sky Mirror Count 6 to 36
      Integer csm_low(16, NUM_SCANS_VAR, 12)

C    *Cold Sky Mirror Count 89
      Integer csm_high(32, NUM_SCANS_VAR, 4)

C    *Rx Offset_Gain Count
      Integer rx_offgain(32, NUM_SCANS_VAR)
      
C    *Latitude of Observation Point for 89A
C    *Longitude of Observation Point for 89A
      COMMON /latlon_89a/ latlon_89a
      character*8 latlon_89a(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)

C    *Latitude of Observation Point for 89B
C    *Longitude of Observation Point for 89B
      COMMON /latlon_89b/ latlon_89b
      character*8 latlon_89b(AM2_DEF_SNUM_HI, NUM_SCANS_VAR)

C    *Sun Azimuth
      Real sun_azim(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Sun Elevation
      Real sun_elev(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Earth Incidence
      Real eth_inci(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Earth Azimuth
      Real eth_azim(AM2_DEF_SNUM_LO, NUM_SCANS_VAR)

C    *Land_Ocean Flag 6 to 36
      Integer lof_low(AM2_DEF_SNUM_LO, NUM_SCANS_VAR, 6)

C    *Land_Ocean Flag 89
      Integer lof_high(AM2_DEF_SNUM_HI, NUM_SCANS_VAR, 2)

C    *Observation Supplement
C    *(Numbef of scans * 248[124 * binary 2byte])
      Character obs_spl(248, NUM_SCANS_VAR)

C    *SPC Temperature Count
      Real spc_temp(34, NUM_SCANS_VAR)

C    *SPS Temperature Count
      Real sps_temp(46, NUM_SCANS_VAR)

C    *PCD Data
      Character pcd_data(64, NUM_SCANS_VAR)

C    *Scan Data Quality
      COMMON /scanqual/ scanqual
      character*512 scanqual(NUM_SCANS_VAR)

C    *Pixel Data Quality 6 to 36
C    *(Numbef of scans * 486[243 * binary 2byte])
      Character pixqual_low(AM2_DEF_SNUM_LO * 2, NUM_SCANS_VAR)

C    *Pixel Data Quality 89
C    *(Numbef of scans * 486[486 * binary 1byte])
      Character pixqual_high(AM2_DEF_SNUM_HI * 1, NUM_SCANS_VAR)

C    *Interpolation Flag 6 to 36
      Character intpol_low(16, NUM_SCANS_VAR, 12)

C    *Interpolation Flag 89
      Character intpol_high(32, NUM_SCANS_VAR, 4)


C--------------------------------------------------------------------C
C    *input data                                                     C
C--------------------------------------------------------------------C

      lines = 0

C     HDF product file open
      file_id = AMTK_openH5(fname)
      if (file_id.lt.0) then
          write(*,*) 'AMTK_openH5 ERROR' ,file_id
          stop
      endif


C     sample meta data read
C     Read Metadata from Metadata file
      open(10, file=meta, status='old')

  555 read(10, 100, end=999) buffer
  100 format(A512)
c
      lines = lines + 1
c
      do i=1,512
          idx(i) = 32
          metadata_name(i) = 32
          max_size(i) = 32
          metadata_value(i) = 32
      end do
c
      i=1
      j=1
   10 if( datax(i).ne.9 ) then
          idx(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 10
      endif
c
      i=i+1
      j=1
   20 if( datax(i).ne.9 ) then
          metadata_name(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 20
      endif
c
      i=i+1
      j=1
   30 if( datax(i).ne.9 ) then
          max_size(j) = datax(i)
          i = i + 1
          j = j + 1
          if (i.ge.512) then
              write(*,*) 'Format ERROR:', meta, ' LINE:', lines
              close(10)
              stop
          endif
          goto 30
      endif
c
      i=i+1
      j=1
   40 if( i.lt.512 .and. datax(i).ne.0 .and. datax(i).ne.9) then
          metadata_value(j) = datax(i)
          i = i + 1
          j = j + 1
          goto 40
      endif

      do i=1,1024
          metadata_area(i) = 32
      end do

      status = AMTK_getMetaDataName(file_id, 
     *    label(2),metadata_area_buff)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      if( status.ne.0) then
         write(*,*) 'No=', lines, 'Name=',label(2),
     *    ' Value=',metadata_area_buff(1:status)
      endif

      goto 555

  999 meta_data_num = lines

      Close(10)


C     Get scan size.
      buf_num_scans = ''
      status = AMTK_getMetaDataName(file_id, 'NumberOfScans',
     *    buf_num_scans)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      READ(buf_num_scans, *) num_scans
      
      buf_num_overlap_scans = ''
      status = AMTK_getMetaDataName(file_id, 'OverlapScans',
     *    buf_num_overlap_scans)
      if (status.lt.0) then
          write(*,*) 'AMTK_getMetaDataName ERROR' ,status
          stop
      endif
      READ(buf_num_overlap_scans, *) num_overlap_scans

      scan_size = num_scans + num_overlap_scans * 2
      scan_start = 1 - num_overlap_scans
      scan_end = num_scans + num_overlap_scans

C     Scan Time
      status = AMTK_getDimSize(file_id, AM2_SCAN_TIME_DEF, dim_size)
      if (status.lt.0) then
          write(*,*) 'AMTK_getDimSize ERROR' ,status
          stop
      endif
      status = AMTK_getScanTime(file_id, scan_start,
     *    scan_end, scan_time)
      if (status.lt.0) then
          write(*,*) 'AMTK_getScanTime ERROR' ,status
          stop
      endif
      write(*,*) status
      Do scan_num =1, PRINT_SCAN_NUM
          AM2_COMMON_SCANTIME = scan_time(scan_num)
          write(*,'(8(A,I4,A))') 'Scan Time No=', scan_num,'  ',
     *        '[' ,year,']  ',
     *        '[' ,month,'/',
     *        ''  ,day,  '] ',
     *        '[' ,hour, ':',
     *        ''  ,minute,':',
     *        ''  ,second,'.',
     *        ''  ,ms,']'
      End do

C     Position in Orbit
      status = AMTK_get_SwathDouble(file_id, pos_orbit, scan_start,
     *                                   scan_end, AM2_POS_ORBIT)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathDouble ERROR' ,status
          stop
      endif

C     Navigation Data
      status = AMTK_get_SwathFloat(file_id, navi, scan_start,
     *                                    scan_end, AM2_NAVI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Attitude Data
      status = AMTK_get_SwathFloat(file_id, att, scan_start,
     *                                    scan_end, AM2_ATT)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Brightness Temperature (6.9GHz,V) ... (36.5GHz,H)
      status = AMTK_get_SwathFloat(file_id, tb06v, scan_start,
     *    scan_end, AM2_TB06V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb06h, scan_start,
     *    scan_end, AM2_TB06H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb07v, scan_start,
     *    scan_end, AM2_TB07V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb07h, scan_start,
     *    scan_end, AM2_TB07H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb10v, scan_start,
     *    scan_end, AM2_TB10V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb10h, scan_start,
     *    scan_end, AM2_TB10H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb18v, scan_start,
     *    scan_end, AM2_TB18V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb18h, scan_start,
     *    scan_end, AM2_TB18H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb23v, scan_start,
     *    scan_end, AM2_TB23V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb23h, scan_start,
     *    scan_end, AM2_TB23H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb36v, scan_start,
     *    scan_end, AM2_TB36V)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb36h, scan_start,
     *    scan_end, AM2_TB36H)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      
C     Brightness Temperature (89GHz-A,V) ... (89GHz-B,H)
      status = AMTK_get_SwathFloat(file_id, tb89av, scan_start,
     *    scan_end, AM2_TB89AV)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb89ah, scan_start,
     *    scan_end, AM2_TB89AH)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb89bv, scan_start,
     *    scan_end, AM2_TB89BV)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
      status = AMTK_get_SwathFloat(file_id, tb89bh, scan_start,
     *    scan_end, AM2_TB89BH)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Hot Load Count 6 to 36
      status = AMTK_get_SwathInt(file_id, hts_low, scan_start,
     *    scan_end, AM2_HTS_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Hot Loat Count 89
      status = AMTK_get_SwathInt(file_id, hts_high, scan_start,
     *    scan_end, AM2_HTS_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Cold Sky Mirror Count 6 to 36
      status = AMTK_get_SwathInt(file_id, csm_low, scan_start,
     *    scan_end, AM2_CSM_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Cold Sky Mirror Count 89
      status = AMTK_get_SwathInt(file_id, csm_high, scan_start,
     *    scan_end, AM2_CSM_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Rx Offset_Gain Count
      status = AMTK_get_SwathInt(file_id, rx_offgain, scan_start,
     *    scan_end, AM2_OFF_GAIN)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
      status = AMTK_getLatLon(file_id, latlon_89a, scan_start,
     *    scan_end, AM2_LATLON_89A)
      if (status.lt.0) then
          write(*,*) 'AMTK_getLatLon ERROR' ,status
          stop
      endif

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
      status = AMTK_getLatLon(file_id, latlon_89b, scan_start,
     *    scan_end, AM2_LATLON_89B)
      if (status.lt.0) then
          write(*,*) 'AMTK_getLatLon ERROR' ,status
          stop
      endif

C     Sun Azimuth
      status = AMTK_get_SwathFloat(file_id, sun_azim, scan_start,
     *    scan_end, AM2_SUN_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Sun Elevation
      status = AMTK_get_SwathFloat(file_id, sun_elev, scan_start,
     *    scan_end, AM2_SUN_EL)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Incidence
      status = AMTK_get_SwathFloat(file_id, eth_inci, scan_start,
     *    scan_end, AM2_EARTH_INC)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     Earth Azimuth
      status = AMTK_get_SwathFloat(file_id, eth_azim, scan_start,
     *    scan_end, AM2_EARTH_AZ)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif
 
C     Land_Ocean Flag 6 to 36
      status = AMTK_get_SwathInt(file_id, lof_low, scan_start,
     *    scan_end, AM2_LOF_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Land_Ocean Flag 89
      status = AMTK_get_SwathInt(file_id, lof_high, scan_start,
     *    scan_end, AM2_LOF_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathInt ERROR' ,status
          stop
      endif

C     Observation Supplement
      status = AMTK_get_SwathUChar(file_id, obs_spl, scan_start,
     *    scan_end, AM2_OB_SPL)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     SPC Temperature Count
      status = AMTK_get_SwathFloat(file_id, spc_temp, scan_start,
     *    scan_end, AM2_SPC_TEMP)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     SPS Temperature Count
      status = AMTK_get_SwathFloat(file_id, sps_temp, scan_start,
     *    scan_end, AM2_SPS_TEMP)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathFloat ERROR' ,status
          stop
      endif

C     PCD Data
      status = AMTK_get_SwathUChar(file_id, pcd_data, scan_start,
     *    scan_end, AM2_PCD)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     Scan Data Quality
      status = AMTK_get_ScanDataQuality(file_id, scanqual, scan_start,
     *    scan_end, AM2_SCAN_QUAL)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_ScanDataQuality ERROR' ,status
          stop
      endif

C     Pixel Data Quality 6 to 36
      status = AMTK_get_SwathUChar(file_id, pixqual_low, scan_start,
     *    scan_end, AM2_PIX_QUAL_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     Pixel Data Quality 89
      status = AMTK_get_SwathUChar(file_id, pixqual_high, scan_start,
     *    scan_end, AM2_PIX_QUAL_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     Interpolation Flag 6 to 36
      status = AMTK_get_SwathUChar(file_id, intpol_low, scan_start,
     *    scan_end, AM2_INTPL_LO)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

C     Interpolation Flag 89
      status = AMTK_get_SwathUChar(file_id, intpol_high, scan_start,
     *    scan_end, AM2_INTPL_HI)
      if (status.lt.0) then
          write(*,*) 'AMTK_get_SwathUChar ERROR' ,status
          stop
      endif

      Do scan_num =1, PRINT_SCAN_NUM

C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num

C         Brightness Temperature (6.9GHz,V) ... (36.5GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (6.9GHz,V)  = ',
     *            tb06v(pixel_num, scan_num),
     *        ' (6.9GHz,H)  = ',
     *            tb06h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (7.3GHz,V)  = ',
     *            tb07v(pixel_num, scan_num),
     *        ' (7.3GHz,H)  = ',
     *            tb07h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (10.7GHz,V) = ',
     *            tb10v(pixel_num, scan_num),
     *        ' (10.7GHz,H) = ',
     *            tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (18.7GHz,V) = ',
     *            tb18v(pixel_num, scan_num),
     *        ' (18.7GHz,H) = ',
     *            tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (23.8GHz,V) = ',
     *            tb23v(pixel_num, scan_num),
     *        ' (23.8GHz,H) = ',
     *            tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (36.5GHz,V) = ',
     *            tb36v(pixel_num, scan_num),
     *        ' (36.5GHz,H) = ',
     *            tb36h(pixel_num, scan_num)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_LO
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num

C         Brightness Temperature (6.9GHz,V) ... (36.5GHz,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (6.9GHz,V)  = ',
     *            tb06v(pixel_num, scan_num),
     *        ' (6.9GHz,H)  = ',
     *            tb06h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (7.3GHz,V)  = ',
     *            tb07v(pixel_num, scan_num),
     *        ' (7.3GHz,H)  = ',
     *            tb07h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (10.7GHz,V) = ',
     *            tb10v(pixel_num, scan_num),
     *        ' (10.7GHz,H) = ',
     *            tb10h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (18.7GHz,V) = ',
     *            tb18v(pixel_num, scan_num),
     *        ' (18.7GHz,H) = ',
     *            tb18h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (23.8GHz,V) = ',
     *            tb23v(pixel_num, scan_num),
     *        ' (23.8GHz,H) = ',
     *            tb23h(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (36.5GHz,V) = ',
     *            tb36v(pixel_num, scan_num),
     *        ' (36.5GHz,H) = ',
     *            tb36h(pixel_num, scan_num)
     
C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
     
C         Brightness Temperature (89GHz-A,V) ... (89GHz-B,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (89GHz-A,V) = ',
     *            tb89av(pixel_num, scan_num),
     *        ' (89GHz-A,H) = ',
     *            tb89ah(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (89GHz-B,V) = ',
     *            tb89bv(pixel_num, scan_num),
     *        ' (89GHz-B,H) = ',
     *            tb89bh(pixel_num, scan_num)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num , ' Pixel = ',
     *        pixel_num

C         Brightness Temperature (89GHz-A,V) ... (89GHz-B,H)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (89GHz-A,V) = ',
     *            tb89av(pixel_num, scan_num),
     *        ' (89GHz-A,H) = ',
     *            tb89ah(pixel_num, scan_num)
          write(*,'(2(A,F4.2))')
     *        'Brightness Temperature (89GHz-B,V) = ',
     *            tb89bv(pixel_num, scan_num),
     *        ' (89GHz-B,H) = ',
     *            tb89bh(pixel_num, scan_num)
     
      End do

C     Latitude of Observation Point for 89A
C     Longitude of Observation Point for 89A
C     write(*,*) 'Latitude/Longitude of Observation Point for 89A'

      Do scan_num =1, PRINT_SCAN_NUM
          AM2_COMMON_LATLON = latlon_89a(pixel_num, scan_num)
          pixel_num = 1
          write(*,'(2(A,I3))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F8.2))') 'Latitude  = ', lat,
     *        '  Longitude = ' ,lon
          
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I3))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F8.2))') 'Latitude  = ', lat,
     *        '  Longitude = ' ,lon
      End do

C     Latitude of Observation Point for 89B
C     Longitude of Observation Point for 89B
C     write(*,*) 'Latitude/Longitude of Observation Point for 89B'
      
      Do scan_num =1, PRINT_SCAN_NUM
          AM2_COMMON_LATLON = latlon_89b(pixel_num, scan_num)
          pixel_num = 1
          write(*,'(2(A,I3))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F8.2))') 'Latitude  = ', lat,
     *        '  Longitude = ' ,lon
          
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I3))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,'(2(A,F8.2))') 'Latitude  = ', lat,
     *        '  Longitude = ' ,lon
      End do

C     Land_Ocean Flag 6 to 36
      Do scan_num =1, PRINT_SCAN_NUM
C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 06GHz = ',
     *        lof_low(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 07GHz = ',
     *        lof_low(pixel_num, scan_num, 2)
          write(*,*) 'Land_Ocean Flag 10GHz = ',
     *        lof_low(pixel_num, scan_num, 3)
          write(*,*) 'Land_Ocean Flag 18GHz = ',
     *        lof_low(pixel_num, scan_num, 4)
          write(*,*) 'Land_Ocean Flag 23GHz = ',
     *        lof_low(pixel_num, scan_num, 5)
          write(*,*) 'Land_Ocean Flag 36GHz = ',
     *        lof_low(pixel_num, scan_num, 6)

C         last pixel
          pixel_num = AM2_DEF_SNUM_LO
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 06GHz = ',
     *        lof_low(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 07GHz = ',
     *        lof_low(pixel_num, scan_num, 2)
          write(*,*) 'Land_Ocean Flag 10GHz = ',
     *        lof_low(pixel_num, scan_num, 3)
          write(*,*) 'Land_Ocean Flag 18GHz = ',
     *        lof_low(pixel_num, scan_num, 4)
          write(*,*) 'Land_Ocean Flag 23GHz = ',
     *        lof_low(pixel_num, scan_num, 5)
          write(*,*) 'Land_Ocean Flag 36GHz = ',
     *        lof_low(pixel_num, scan_num, 6)
      End do
      
C     Land_Ocean Flag 89
      Do scan_num =1, PRINT_SCAN_NUM
C         first pixel
          pixel_num = 1
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 89AGHz = ',
     *        lof_high(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 89BGHz = ',
     *        lof_high(pixel_num, scan_num, 2)
     
C         last pixel
          pixel_num = AM2_DEF_SNUM_HI
          write(*,'(2(A,I4))') 'Scan = ', scan_num, ' Pixel = ',
     *        pixel_num
          write(*,*) 'Land_Ocean Flag 89AGHz = ',
     *        lof_high(pixel_num, scan_num, 1)
          write(*,*) 'Land_Ocean Flag 89BGHz = ',
     *        lof_high(pixel_num, scan_num, 2)
      End do
      
      
C     HDF product file close (write mode)
      status = AMTK_closeH5(file_id)
      if (status.lt.0) then
          write(*,*) 'AMTK_closeH5 ERROR' ,status
          stop
      endif
      
      Write(*,*) 'L1B product read end'

      Stop
      End
      
