/*****************************************************************************/
/*  Copyright (C) NEC Corporation 2010 All rights reserved.                  */
/*  File Name    : IOTK_common.h                                             */
/*  Abstract     : IO toolkit  header file                                   */
/*                                                                           */
/*  Author     NEC                                                           */
/*  Date       2010/06/30                                                    */
/*  Version    1.000                                                         */
/*  Notice                                                                   */
/*****************************************************************************/
#ifndef IOTK_COMMON_H
#define IOTK_COMMON_H

#include "AMTK_PLUS.h"

#ifdef LINUX
#include <byteswap.h>
#endif


#define IOTK_ON		1
#define IOTK_OFF	0

#define SUCCESS						(0)
#define FAIL						(-1)
#define ERROR_FILE_OPEN				(-100)
#define ERROR_MALLOC				(-101)
#define ERROR_ENV_NAME				(-102)
#define ERROR_LEAP_SEC				(-103)
#define ERROR_DIR_OPEN				(-104)
#define ERROR_FILE_READ				(-105)
#define ERROR_FILE_CLOS				(-106)
#define ERROR_FILE_SEQ				(-107)
#define ERROR_FILE_SIZE				(-108)
#define ERROR_GEOPHSICAL_FILE		(-109)

#define ERROR_ILLEGAL_YEAR			(-201)
#define ERROR_ILLEGAL_MONTH			(-202)
#define ERROR_ILLEGAL_DAY			(-203)
#define ERROR_ILLEGAL_HOUR			(-204)
#define ERROR_ILLEGAL_MIN			(-205)
#define ERROR_ILLEGAL_SEC			(-206)
#define ERROR_ILLEGAL_MS			(-207)
#define ERROR_ILLEGAL_DATE			(-208)
#define ERROR_ILLEGAL_TOTALSEC		(-209)
#define ERROR_ILLEGAL_FILENAME		(-210)
#define ERROR_ILLEGAL_SCANNUM_S		(-211)
#define ERROR_ILLEGAL_SCANNUM_E		(-212)
#define ERROR_ILLEGAL_HDF_FILEID	(-213)
#define ERROR_ILLEGAL_INDEX			(-214)
#define ERROR_ILLEGAL_DIMS			(-215)
#define ERROR_NOT_WRITEDATA			(-216)
#define ERROR_NOT_ACCESSLABEL		(-217)
#define ERROR_ACCESSLABEL_WRITE_NG	(-218)
#define ERROR_ACCESSLABEL_READ_NG	(-219)
#define ERROR_MEMSIZE				(-220)
#define ERROR_NULL_ADDRESS			(-221)
#define ERROR_ILLEGAL_METADATA		(-222)
#define ERROR_ILLEGAL_TFLG			(-223)
#define ERROR_ILLEGAL_PRMG			(-224)
#define ERROR_ILLEGAL_PRMA			(-225)
#define ERROR_ILLEGAL_LEV			(-226)
#define ERROR_ILLEGAL_LAT			(-227)
#define ERROR_ILLEGAL_LON			(-228)
#define ERROR_ILLEGAL_IFLG			(-229)
#define ERROR_NOT_TARGET_FILE		(-230)
#define ERROR_ILLEGAL_SECTIONNO		(-231)
#define ERROR_ILLEGAL_NPIX			(-232)
#define ERROR_ILLEGAL_HEIGHT		(-233)
#define ERROR_ILLEGAL_DPIX			(-234)
#define ERROR_ILLEGAL_ELV			(-235)
#define ERROR_ILLEGAL_AZM			(-236)
#define ERROR_ILLEGAL_GRID			(-237)
#define ERROR_ILLEGAL_MODE			(-238)
#define ERROR_ACCESSLABEL_UNMATCH	(-239)
#define ERROR_GRID03D_GEONAME		(-250)
#define ERROR_GRID03D_ORBITDIR		(-251)
#define ERROR_GRID03D_PRDCTDATE		(-252)
#define ERROR_GRID03D_GEOSIZE		(-253)

#define ERROR_HDF_FILE_OPEN			(-501)
#define ERROR_HDF_FILE_CLOSE		(-502)
#define ERROR_HDF_DIMENSION_SIZE	(-502)
#define ERROR_DATASET_ACCESSES		(-503)
#define ERROR_HDF_DATASET_OPEN		(-504)
#define ERROR_HDF_DATASET_GET_SPACE	(-505)
#define ERROR_HDF_DATASET_GET_RANK	(-506)
#define ERROR_HDF_DATASET_GET_DIMS	(-507)
#define ERROR_HDF_DATASET_CREATE	(-508)
#define ERROR_HDF_DATASET_WRITE		(-509)
#define ERROR_HDF_DATASET_READ		(-510)
#define ERROR_HDF_DATASET_GET_TYPE  (-511)
#define ERROR_HDF_ATTR_NAME_OPEN	(-520)
#define ERROR_HDF_ATTR_GET_TYPE		(-521)
#define ERROR_HDF_ATTR_READ			(-522)
#define ERROR_HDF_ATTR_IDX_OPEN		(-523)
#define ERROR_HDF_ATTR_CREATE		(-524)
#define ERROR_HDF_ATTR_WRITE		(-525)
#define ERROR_HDF_DT_GET_CLASS		(-526)
#define ERROR_HDF_DT_COPY			(-527)
#define ERROR_HDF_DT_SET_SIZE		(-528)
#define ERROR_HDF_DT_GET_TYPE		(-529)

#define ERROR_HDF_CREATE_SPACE		(-540)
#define ERROR_HDF_HYPERSLAB			(-541)

#define ERROR_HDF_METAOP_PRDCTNAME	(-550)
#define ERROR_HDF_METANG_PRDCTNAME	(-551)
#define ERROR_HDF_METAOP_OVERLAP	(-552)
#define ERROR_HDF_METANG_OVERLAP	(-553)
#define ERROR_HDF_METAOP_GEONAME	(-554)
#define ERROR_HDF_METANG_GEONAME	(-555)
#define ERROR_HDF_METAOP_GRANULE	(-556)
#define ERROR_HDF_METANG_GRANULE	(-557)
#define ERROR_HDF_METAOP_COREGA1	(-558)
#define ERROR_HDF_METANG_COREGA1	(-559)
#define ERROR_HDF_METAOP_COREGA2	(-560)
#define ERROR_HDF_METANG_COREGA2	(-561)
#define ERROR_HDF_METAOP_PRJCTION	(-562)
#define ERROR_HDF_METANG_PRJCTION	(-563)
#define ERROR_HDF_METAOP_ORBITDIR	(-564)
#define ERROR_HDF_METANG_ORBITDIR	(-565)
#define ERROR_HDF_METAOP_PRDCTDTM	(-566)
#define ERROR_HDF_METANG_PRDCTDTM	(-567)

#define ERROR_ILLEGAL_DATA_TYPE		(-601)
#define ERROR_MINMAX_CHECK			(-602)
#define WARNING_DATA                (9999)

#define CONST_A        (6.378137e6)          /* Eareth Eqatorial radius (WGS-84) */
#define CONST_F        (1.0/298.257223563)   /* Eareth f (WGS-84)*/
#define CONST_B        (CONST_A*(1.0-(CONST_F)))   /* Eareth short radius */
#define CONST_E2       (2.0*(CONST_F) - (CONST_F)*(CONST_F))  /* e*e  */
#define CONST_E2_DASH  ((CONST_A*CONST_A - CONST_B*CONST_B)/(CONST_B*CONST_B))  /* e'*e'  */

#undef  M_PI
#define M_PI (3.14159265358979323846)
#define RADDEG(x)     ((x)*(180.0)/(M_PI))
#define DEGRAD(x)     ((x)*(M_PI)/(180.0))

/*****************************************************************************/
/*    Function prototypes                                                    */
/*****************************************************************************/

/*************************************************************/
int IOTK_printf(const char *form, ...);
void IOTK_DebugCheck(void);
char *string_check_fortran(char* original, int length);
int DateToSec(AM2_COMMON_SCANTIME date,int *total_sec);
int SecToDate(int total_sec, AM2_COMMON_SCANTIME *date);
int checkScanTimeData(AM2_COMMON_SCANTIME *date);
/*************************************************************/


#endif
